#include <stdio.h>
#include <stdarg.h>
#include "mprintf.h"
#include "mlog.h"

static void (*log_func)(void *,const char *,size_t);
static void *log_arg;
static int  log_level;

void mlog_set(void (*f)(void *,const char*,size_t), void *arg)
{
  log_func= f;
  log_arg= arg;
}

void mlog_level(int level)
{
  log_level= level;
}

static void out_stderr(void *dummy, const char *str, size_t len)
{
  fwrite(str, 1, len, stderr);
}

void mlog(int level, const char *fmt, ...)
{
  va_list ap;

  if (level>log_level) return;

  va_start(ap,fmt);
  if (!log_func) log_func= out_stderr;
  vgprintf(log_func, log_arg, fmt, ap);
  va_end(ap);
}


