#line 126 "/home/dodo/btstack/src/aread.u"

#include <stdint.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include "socket.h"

#line 10 "/home/dodo/btstack/src/aread.u"

typedef struct {
  int extra_hdr;
  int len, size;
  int allocd;
  uint8_t *buffer;
  socket_t *socket;
  char hdr[2];
  int hdr_len;
  int complete, error;
  char errstr[2000];
} areader_t;


#line 25 "/home/dodo/btstack/src/aread.u"

areader_t *aread_init(socket_t *socket, int extra_hdr)
{
  areader_t *A;
  A= calloc(1,sizeof(*A));
  A->extra_hdr= extra_hdr;
  A->socket= socket;

  A->allocd= 1024;
  A->buffer= malloc(A->allocd);
  return A;
}

#line 43 "/home/dodo/btstack/src/aread.u"

int aread_go(areader_t *A)
{
  int R;
  char *tgt; int tlen;
  int ESZ= sizeof(A->errstr);

  if (A->hdr_len<2) { tgt= A->hdr; tlen= 2-A->hdr_len; }
  else { tgt= A->buffer+A->extra_hdr+A->len; tlen= A->size-A->len; }

  R= recv(A->socket->fd, tgt, tlen, MSG_DONTWAIT);

  if (R==0) // closed socket
  {
    A->error= ECONNRESET;
    A->errstr[ESZ]= 0;
    snprintf(A->errstr, ESZ-1, "Connection reset");
    return 1;
  }
  if (R<0)
  {
    if (errno==EINTR || errno==EAGAIN || errno==EWOULDBLOCK)
     return 0;
    A->error= errno;
    A->errstr[ESZ]= 0;
    snprintf(A->errstr, ESZ-1, "%d: (%s)", errno,strerror(errno));
    return 1;
  }

  if (A->hdr_len<2)
  {
    A->hdr_len+= R;
    A->size= A->hdr[0] | (A->hdr[1]<<8);
    if (A->size==0) { A->complete=1; return 0; }

    if (A->allocd<(A->size+A->extra_hdr))
    {
      A->allocd= A->size+A->extra_hdr;
      free(A->buffer);
      A->buffer= malloc(A->size+A->extra_hdr);
    }
    return 0;
  }

  A->len+= R;
  if (A->len==A->size)
  {
    A->complete= 1;
    return 1;
  }
  return 0;
}

void aread_start(areader_t *A)
{
  A->hdr_len= 0;
  A->len= 0;
  A->size= 0;
  A->complete= 0;
  A->error= 0;
  A->errstr[0]= 0;
}

void aread_free(areader_t *A)
{
  free(A->buffer);
  free(A);
}

#line 137 "/home/dodo/btstack/src/aread.u"

