#line 172 "/home/dodo/btstack/src/channels.u"
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "util.h"
#include "channels.h"

#line 21 "/home/dodo/btstack/src/channels.u"

typedef struct chan {
  uint16_t cid;
  time_t ttl;  // time to live
  time_t last_update; 
} channel_t;

#line 29 "/home/dodo/btstack/src/channels.u"

static channel_t **live_channels;
static channel_t **dead_channels;
static int n_live_channels, s_live_channels;
static int n_dead_channels, s_dead_channels;
static uint16_t last= 0x0020;

#line 196 "/home/dodo/btstack/src/channels.u"

static channel_t *find_channel(channel_t **list, int N, uint16_t cid)
{
  int i;
  for(i=0;i<N;i++)
    if (list[i]->cid==cid)
     return list[i];
  return NULL;
}

#line 37 "/home/dodo/btstack/src/channels.u"

uint16_t alloc_local_cid()
{
  channel_t *C;
  uint16_t R;
  int tried;

  tried= 0;

again:
  if (tried==0xffff-0x0040)
     goto exhausted;
  last++;
  R= (last)%(0xffff-0x0040)+ 0x0040;
  tried++;
  if (find_channel(dead_channels,n_dead_channels, R)||
      find_channel(live_channels,n_live_channels, R)) goto again;

  C= malloc(sizeof(*C));
  C->cid= R;
  pvecapd(live_channels,C);
  return R;
#line 69 "/home/dodo/btstack/src/channels.u"

exhausted:
  printf("Exhausted local cid's : a very unlikely thing happened\n");
  *(int*) NULL= 0;
  return 0;

#line 60 "/home/dodo/btstack/src/channels.u"
}

#line 83 "/home/dodo/btstack/src/channels.u"

void release_local_cid(uint16_t cid)
{
  channel_t *C;
  int i;
  C= NULL;
  for(i=0;i<n_live_channels;i++)
    if (live_channels[i]->cid==cid)
    {
      C= live_channels[i];
      pvecdel(live_channels,i);
      break;
    }
  if (!C)
   {
     C= find_channel(dead_channels, n_dead_channels, cid);
     if (C) return ;
     C= malloc(sizeof(*C));
     C->cid= cid;
   }

  C->ttl= 60; // one minute is more than enough, I think.
  C->last_update= time(NULL);
  pvecapd(dead_channels, C);
}

#line 116 "/home/dodo/btstack/src/channels.u"

void local_cids_beat()
{
  static uint32_t K;
  int i;
  time_t T;
  K= (K+1)%200;  // 200 dead can be in the cemetary at once
  if (K) return ;

  T= time(NULL);
  for(i=0;i<n_dead_channels;i++)
  {
    time_t D;
    channel_t *C;
    C= dead_channels[i];
    D= T - C->last_update;
    if (D<C->ttl)
    {
       C->ttl -= D;
       C->last_update= T;
    }
    else
    {
       pvecdel(dead_channels, i);
       i--;
       local_cid_done(C->cid);
       free(C);
    }
  }
}

#line 188 "/home/dodo/btstack/src/channels.u"

void local_cids_init()
{
  pvecini(&live_channels, &s_live_channels, &n_live_channels);
  pvecini(&dead_channels, &s_dead_channels, &n_dead_channels);
}

#line 183 "/home/dodo/btstack/src/channels.u"

