
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <db.h>


int db_init();
static int dbget(DBT*key, DBT *val);
static int dbput(DBT*key, DBT *val);
static void dbclose();


static DB *dbp;


int db_init()
{
  int R;
  R= db_create(&dbp, NULL,0);
  if (R)
  {
    dbp= NULL;
    printf("db_create: %s\n", db_strerror(R));
    return 1;
  }

  R= dbp->open(dbp, NULL, "./daemondb", NULL, DB_BTREE, DB_CREATE, 0664);
  if (R)
  {
    dbp->err(dbp, R, "%s", "open");
    dbp= NULL; // FIXME: we should 'uncreate' the pointer somehow
    return 1;
  }

  atexit(dbclose);
  return 0;
}


static int dbget(DBT*key, DBT *val)
{
  return dbp->get(dbp, NULL, key, val, 0);
}

static int dbput(DBT*key, DBT *val)
{
  return dbp->put(dbp, NULL, key, val, 0);
}


static void dbclose()
{
  if (dbp) dbp->close(dbp,0);
}

int dp_device_link_key(uint8_t *k0,uint8_t *d0)
{
  uint8_t kbuf[8];
  uint8_t dbuf[16];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 16;
  kbuf[0]= 64;
  kbuf[1]= 0;
  memcpy(kbuf+2, k0, 6);
  memcpy(dbuf+0, d0, 16);
  return dbput(&key,&val);
}
int dp_device_pin_code(uint8_t *k0,uint8_t d0,uint8_t *d1)
{
  uint8_t kbuf[8];
  uint8_t dbuf[17];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 17;
  kbuf[0]= 64;
  kbuf[1]= 1;
  memcpy(kbuf+2, k0, 6);
  dbuf[0]= d0;
  memcpy(dbuf+1, d1, 16);
  return dbput(&key,&val);
}
int dp_device_psrm(uint8_t *k0,uint8_t d0)
{
  uint8_t kbuf[8];
  uint8_t dbuf[1];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 1;
  kbuf[0]= 64;
  kbuf[1]= 2;
  memcpy(kbuf+2, k0, 6);
  dbuf[0]= d0;
  return dbput(&key,&val);
}
int dp_device_class(uint8_t *k0,uint8_t *d0)
{
  uint8_t kbuf[8];
  uint8_t dbuf[3];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 3;
  kbuf[0]= 64;
  kbuf[1]= 3;
  memcpy(kbuf+2, k0, 6);
  memcpy(dbuf+0, d0, 3);
  return dbput(&key,&val);
}
int dg_device_link_key(uint8_t *k0,uint8_t *d0)
{
  int R;
  uint8_t kbuf[8];
  uint8_t dbuf[16];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 16;
  kbuf[0]= 64;
  kbuf[1]= 0;
  memcpy(kbuf+2, k0, 6);
  R= dbget(&key,&val);
  if (R) return R;
  memcpy(d0, dbuf+0,16);
  return 0;
}
int dg_device_pin_code(uint8_t *k0,uint8_t *d0,uint8_t *d1)
{
  int R;
  uint8_t kbuf[8];
  uint8_t dbuf[17];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 17;
  kbuf[0]= 64;
  kbuf[1]= 1;
  memcpy(kbuf+2, k0, 6);
  R= dbget(&key,&val);
  if (R) return R;
  *d0= dbuf[0];
  memcpy(d1, dbuf+1,16);
  return 0;
}
int dg_device_psrm(uint8_t *k0,uint8_t *d0)
{
  int R;
  uint8_t kbuf[8];
  uint8_t dbuf[1];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 1;
  kbuf[0]= 64;
  kbuf[1]= 2;
  memcpy(kbuf+2, k0, 6);
  R= dbget(&key,&val);
  if (R) return R;
  *d0= dbuf[0];
  return 0;
}
int dg_device_class(uint8_t *k0,uint8_t *d0)
{
  int R;
  uint8_t kbuf[8];
  uint8_t dbuf[3];
  DBT key,val;
  if (!dbp) return 1;
  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= 8;
  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= 3;
  kbuf[0]= 64;
  kbuf[1]= 3;
  memcpy(kbuf+2, k0, 6);
  R= dbget(&key,&val);
  if (R) return R;
  memcpy(d0, dbuf+0,3);
  return 0;
}
