#line 304 "/home/dodo/btstack/src/event.u"
#include <stdint.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "event.h"

#line 9 "event.c"

static void event_set_field(uint8_t *event, int index, int value);
static int event_get_field(uint8_t *event, int index);
int event_match_2(uint32_t *mask, uint8_t *event,uint8_t **result);
static event_t* event_remove_list(event_t *E);
static void event_add_list(event_t *E, event_t* H);
#line 224 "/home/dodo/btstack/src/event.u"

event_t events= { &events, &events };
static event_t evnodes= { &evnodes, &evnodes };

#line 30 "/home/dodo/btstack/src/event.u"

void event_set_size(uint8_t *event, int size)
  { event_set_field(event, 0, size); }

int event_get_size(uint8_t *event)
  { return event_get_field(event,0); }

void event_set_length(uint8_t *event, int length)
  { event_set_field(event, 2, length); }

int event_get_length(uint8_t *event)
  { return event_get_field(event,2); }

void event_set_code(uint8_t *event, int code)
  { event_set_field(event, 4, code); }

int event_get_code(uint8_t *event)
  { return event_get_field(event,4); }

#line 69 "/home/dodo/btstack/src/event.u"

uint8_t *event_get_payload(uint8_t *event)
{
  return event+EVENT_HEADER_SIZE;
}

#line 146 "/home/dodo/btstack/src/event.u"

void system_event(int code, const char *fmt, ...)
{
   uint8_t *buffer;
   size_t size;
   uint8_t *ptr;
   va_list ap;
   int i;
   int iarg; uint8_t *parg;

   int param_size;

   param_size= 0;
   va_start(ap,fmt);
   for(i=0;fmt[i];i++)
     switch(fmt[i])
     {
       case 'b': param_size++; iarg= va_arg(ap,int); break;
       case 'w': param_size+=2; iarg= va_arg(ap,int); break;
       case 'd': param_size+=4; iarg= va_arg(ap,int); break;
       case 'p': iarg= va_arg(ap,int); param_size+= iarg;
                 parg= va_arg(ap,uint8_t*); break;
     }
   va_end(ap);

   size= EVENT_HEADER_SIZE+2+param_size;

   buffer= malloc(size);
   event_set_size(buffer,size);
   event_set_length(buffer, param_size + 2);
   event_set_code(buffer, EVENT_system);

   buffer[EVENT_HEADER_SIZE+0]= code & 0xff;
   buffer[EVENT_HEADER_SIZE+1]= code >> 8;

   
   ptr= buffer + EVENT_HEADER_SIZE + 2;

   va_start(ap,fmt);
   for(i=0;fmt[i];i++)
     switch(fmt[i])
     {
       case 'b': iarg= va_arg(ap,int);
                 *(ptr++)= iarg;
                 break;
       case 'w': iarg= va_arg(ap,int);
                 *(ptr++)= iarg;
                 *(ptr++)= iarg>>8;
                 break;
       case 'd': iarg= va_arg(ap,int);
                 *(ptr++)= iarg;
                 *(ptr++)= iarg>>8;
                 *(ptr++)= iarg>>16;
                 *(ptr++)= iarg>>24;
                 break;
       case 'p': iarg= va_arg(ap,int);
                 parg= va_arg(ap,uint8_t*);
                 memcpy(ptr, parg, iarg);
                 ptr+= iarg;
                 break;
     }
   va_end(ap);

   event_dispatch(buffer);
}

#line 235 "/home/dodo/btstack/src/event.u"

uint8_t *event_dequeue(event_t *E)
{
  uint8_t *R;
  R= E->event;
  event_remove_list(E);
  event_add_list(E, &evnodes);
  E->event= NULL;
  return R;
}

void event_queue(uint8_t *event)
{
  event_t *E;
  if (evnodes.next==&evnodes)
  {
    event_t *EVS;
    int N,i;
    N= 20;
    EVS= malloc(sizeof(*EVS)*N);
    for(i=0;i<N;i++)
      event_add_list(EVS+i, &evnodes);
  }
  E= event_remove_list(evnodes.next);
  E->event= event;
  event_add_list(E, &events);
}

#line 327 "/home/dodo/btstack/src/event.u"

void remove_socket_events(int fd)
{
  event_t *E,*N;
  static uint32_t emask[255];
  static int emask_ok=0;
  uint8_t *result[2];
  int efd;

  if (!emask_ok)
  {
#line 155 "event.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0007<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x000e<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x08),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0015<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x09),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x03), 
(0x03<<24) | (0x001c<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0a),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x04), 
(0x02<<24)  | (0),
};
memcpy( emask, _TPL, sizeof(_TPL));
} while(0);
switch( 1){
case 1:
break;
case 2:
break;
case 3:
break;
case 4:
break;
}
#line 351 "/home/dodo/btstack/src/event.u"
    emask_ok= 1;
  }

  for(E=events.next;E!=&events;E=N)
  {
    N= E->next;
    if (!event_match_2(emask, E->event, result))
       continue;
    efd= *(int*) (result[0]);
    if (efd!=fd) continue;
    free(event_dequeue(E));
  }
}
#line 50 "/home/dodo/btstack/src/event.u"

static void event_set_field(uint8_t *event, int index, int value)
{
  event[index++]= value & 0xff;
  event[index++]= value>>8;
}

static int event_get_field(uint8_t *event, int index)
{
  int K= 0;
  K |= event[index++];
  K |= event[index++] << 8;
  return K;
}

#line 110 "/home/dodo/btstack/src/event.u"

int event_match_2(uint32_t *mask, uint8_t *event,uint8_t **result)
{
  uint16_t E;
  uint16_t P;
  uint16_t offset; uint8_t value; uint8_t opcode; uint32_t M;
  P= 0;
  while(1)
  {
     M= mask[P++];
     offset= (M & 0xffff00)>>8;
     value= M;
     opcode= M >> 24;
     switch(opcode)
     {
       case 3: E= offset; break; // error declaration 
       case 2: return value;
       case 4: result[value]= event+offset; break; // store
       case 1: if (event[offset]!=value) P= E; break;
     }
  }
}

#line 264 "/home/dodo/btstack/src/event.u"

static event_t* event_remove_list(event_t *E)
{
  E->prev->next= E->next;
  E->next->prev= E->prev;
  return E;
}

static void event_add_list(event_t *E, event_t* H)
{
  E->next= H;
  E->prev= H->prev;
  H->prev->next= E;
  H->prev= E;
}

#line 317 "/home/dodo/btstack/src/event.u"

// Event printer
#line 273 "event.c"
void print_event(uint8_t *event){
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x03) {
printf("HCI_connection_complete\n");
printf("  status %02x\n",event[8]);
printf("  connection_handle %04x\n",event[9] | (event[10]<<8));
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[11],event[12],event[13],event[14],event[15],event[16]);
printf("  link_type %02x\n",event[17]);
printf("  encryption_enabled %02x\n",event[18]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x02) {
printf("HCI_inquiry_result\n");
printf("  num_responses %02x\n",event[8]);
printf("  data %02x\n",event[9]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x22) {
printf("HCI_inquiry_result_with_rssi\n");
printf("  num_responses %02x\n",event[8]);
printf("  data %02x\n",event[9]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x01) {
printf("HCI_inquiry_complete\n");
printf("  status %02x\n",event[8]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0e && event[9]==0x0b && event[10]==0x04) {
printf("HCI_link_key_request_reply_command_complete\n");
printf("  n_hci %02x\n",event[8]);
printf("  status %02x\n",event[11]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[12],event[13],event[14],event[15],event[16],event[17]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0e && event[9]==0x0c && event[10]==0x04) {
printf("HCI_link_key_request_negative_reply_command_complete\n");
printf("  n_hci %02x\n",event[8]);
printf("  status %02x\n",event[11]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[12],event[13],event[14],event[15],event[16],event[17]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0f) {
printf("HCI_command_status\n");
printf("  status %02x\n",event[8]);
printf("  n_hci %02x\n",event[9]);
printf("  opcode %04x\n",event[10] | (event[11]<<8));
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0e && event[9]==0x05 && event[10]==0x10) {
printf("HCI_read_buffer_size_command_complete\n");
printf("  n_hci %02x\n",event[8]);
printf("  status %02x\n",event[11]);
printf("  acl_data_packet_length %04x\n",event[12] | (event[13]<<8));
printf("  synchronous_data_packet_length %02x\n",event[14]);
printf("  total_num_acl_data_packets %04x\n",event[15] | (event[16]<<8));
printf("  total_num_synchronous_data_packets %04x\n",event[17] | (event[18]<<8));
return;
}
if (event[4]==0x01 && event[5]==0x00) {
printf("ACL_packet\n");
printf("  connection_handle %04x\n",event[6] | (event[7]<<8));
printf("  acl_length %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  channel_id %04x\n",event[12] | (event[13]<<8));
printf("  l2cap_data %02x\n",event[14]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x13) {
printf("HCI_number_of_completed_packets\n");
printf("  nresults %02x\n",event[8]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x1b) {
printf("HCI_max_slots_change\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  lmp_max_slots %02x\n",event[10]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x05) {
printf("HCI_disconnection_complete\n");
printf("  status %02x\n",event[8]);
printf("  connection_handle %04x\n",event[9] | (event[10]<<8));
printf("  reason %02x\n",event[11]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x13) {
printf("HCI_Number_of_Completed_Packets\n");
printf("  Number_of_Handles %02x\n",event[8]);
printf("  data %02x\n",event[9]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0e) {
printf("HCI_command_complete_with_status\n");
printf("  n_hci %02x\n",event[8]);
printf("  opcode %04x\n",event[9] | (event[10]<<8));
printf("  status %02x\n",event[11]);
printf("  data %02x\n",event[12]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x0e) {
printf("HCI_command_complete\n");
printf("  n_hci %02x\n",event[8]);
printf("  opcode %04x\n",event[9] | (event[10]<<8));
printf("  data %02x\n",event[11]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x01) {
printf("L2CAP_command_reject\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  reason %02x\n",event[18]);
printf("  data %02x\n",event[20]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x02) {
printf("L2CAP_connection_request\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  psm %04x\n",event[18] | (event[19]<<8));
printf("  source_cid %04x\n",event[20] | (event[21]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x03) {
printf("L2CAP_connection_response\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  destination_cid %04x\n",event[18] | (event[19]<<8));
printf("  source_cid %04x\n",event[20] | (event[21]<<8));
printf("  result %04x\n",event[22] | (event[23]<<8));
printf("  status %04x\n",event[24] | (event[25]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x04) {
printf("L2CAP_configuration_request\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  destination_cid %04x\n",event[18] | (event[19]<<8));
printf("  flags %04x\n",event[20] | (event[21]<<8));
printf("  options %02x\n",event[22]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x05) {
printf("L2CAP_configuration_response\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  source_cid %04x\n",event[18] | (event[19]<<8));
printf("  flags %04x\n",event[20] | (event[21]<<8));
printf("  result %04x\n",event[22] | (event[23]<<8));
printf("  options %02x\n",event[24]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x06) {
printf("L2CAP_disconnection_request\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  destination_cid %04x\n",event[18] | (event[19]<<8));
printf("  source_cid %04x\n",event[20] | (event[21]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x07) {
printf("L2CAP_disconnection_response\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  destination_cid %04x\n",event[18] | (event[19]<<8));
printf("  source_cid %04x\n",event[20] | (event[21]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x08) {
printf("L2CAP_echo_request\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  data %02x\n",event[18]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x09) {
printf("L2CAP_echo_response\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  data %02x\n",event[18]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x0a) {
printf("L2CAP_information_request\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  info_type %04x\n",event[18] | (event[19]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00 && event[14]==0x0b) {
printf("L2CAP_information_response\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  info_type %04x\n",event[18] | (event[19]<<8));
printf("  result %04x\n",event[20] | (event[21]<<8));
printf("  data %02x\n",event[22]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00 && event[12]==0x01 && event[13]==0x00) {
printf("L2CAP_unknown_command\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  opcode %02x\n",event[14]);
printf("  identifier %02x\n",event[15]);
printf("  cmd_data_length %04x\n",event[16] | (event[17]<<8));
printf("  data %02x\n",event[18]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x3d) {
printf("HCI_remote_host_supported_features_notification\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  featL %08x\n",event[14] | (event[15]<<8) | (event[16]<<16) | (event[17]<<24));
printf("  featH %08x\n",event[18] | (event[19]<<8) | (event[20]<<16) | (event[21]<<24));
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x07) {
printf("HCI_remote_name_request_complete\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  status %02x\n",event[8]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[9],event[10],event[11],event[12],event[13],event[14]);
printf("  remote_name %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x\n",event[15],event[16],event[17],event[18],event[19],event[20],event[21],event[22],event[23],event[24],event[25],event[26],event[27],event[28],event[29],event[30],event[31],event[32],event[33],event[34],event[35],event[36],event[37],event[38],event[39],event[40],event[41],event[42],event[43],event[44],event[45],event[46],event[47],event[48],event[49],event[50],event[51],event[52],event[53],event[54],event[55],event[56],event[57],event[58],event[59],event[60],event[61],event[62],event[63],event[64],event[65],event[66],event[67],event[68],event[69],event[70],event[71],event[72],event[73],event[74],event[75],event[76],event[77],event[78],event[79],event[80],event[81],event[82],event[83],event[84],event[85],event[86],event[87],event[88],event[89],event[90],event[91],event[92],event[93],event[94],event[95],event[96],event[97],event[98],event[99],event[100],event[101],event[102],event[103],event[104],event[105],event[106],event[107],event[108],event[109],event[110],event[111],event[112],event[113],event[114],event[115],event[116],event[117],event[118],event[119],event[120],event[121],event[122],event[123],event[124],event[125],event[126],event[127],event[128],event[129],event[130],event[131],event[132],event[133],event[134],event[135],event[136],event[137],event[138],event[139],event[140],event[141],event[142],event[143],event[144],event[145],event[146],event[147],event[148],event[149],event[150],event[151],event[152],event[153],event[154],event[155],event[156],event[157],event[158],event[159],event[160],event[161],event[162],event[163],event[164],event[165],event[166],event[167],event[168],event[169],event[170],event[171],event[172],event[173],event[174],event[175],event[176],event[177],event[178],event[179],event[180],event[181],event[182],event[183],event[184],event[185],event[186],event[187],event[188],event[189],event[190],event[191],event[192],event[193],event[194],event[195],event[196],event[197],event[198],event[199],event[200],event[201],event[202],event[203],event[204],event[205],event[206],event[207],event[208],event[209],event[210],event[211],event[212],event[213],event[214],event[215],event[216],event[217],event[218],event[219],event[220],event[221],event[222],event[223],event[224],event[225],event[226],event[227],event[228],event[229],event[230],event[231],event[232],event[233],event[234],event[235],event[236],event[237],event[238],event[239],event[240],event[241],event[242],event[243],event[244],event[245],event[246],event[247],event[248],event[249],event[250],event[251],event[252],event[253],event[254],event[255],event[256],event[257],event[258],event[259],event[260],event[261],event[262]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x16) {
printf("HCI_pin_code_request\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x17) {
printf("HCI_link_key_request\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x18) {
printf("HCI_link_key_notification\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  link_key %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x\n",event[14],event[15],event[16],event[17],event[18],event[19],event[20],event[21],event[22],event[23],event[24],event[25],event[26],event[27],event[28],event[29]);
printf("  type %02x\n",event[30]);
return;
}
if (event[4]==0x02 && event[5]==0x00 && event[6]==0x04) {
printf("HCI_Connection_Request\n");
printf("  hci_evlen %02x\n",event[7]);
printf("  bd_addr %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  class_of_device %02x:%02x:%02x\n",event[14],event[15],event[16]);
printf("  link_type %02x\n",event[17]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x02 && event[7]==0x00) {
printf("SYS_control_transfer_done\n");
printf("  identifier %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
printf("  status %08x\n",event[12] | (event[13]<<8) | (event[14]<<16) | (event[15]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x03 && event[7]==0x00) {
printf("SYS_transport_error\n");
printf("  kind %04x\n",event[8] | (event[9]<<8));
printf("  code %08x\n",event[10] | (event[11]<<8) | (event[12]<<16) | (event[13]<<24));
printf("  string_error %02x\n",event[14]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x06 && event[7]==0x00) {
printf("SYS_acl_transfer_done\n");
printf("  identifier %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
printf("  status %08x\n",event[12] | (event[13]<<8) | (event[14]<<16) | (event[15]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x07 && event[7]==0x00) {
printf("SYS_socket_readable\n");
printf("  fd %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x08 && event[7]==0x00) {
printf("SYS_socket_writable\n");
printf("  fd %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x09 && event[7]==0x00) {
printf("SYS_socket_read_exception\n");
printf("  fd %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x0a && event[7]==0x00) {
printf("SYS_socket_write_exception\n");
printf("  fd %08x\n",event[8] | (event[9]<<8) | (event[10]<<16) | (event[11]<<24));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x12 && event[7]==0x00) {
printf("SYS_connect_device\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x13 && event[7]==0x00) {
printf("SYS_device_connected\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  connection_handle %04x\n",event[14] | (event[15]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x14 && event[7]==0x00) {
printf("SYS_device_not_connected\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x15 && event[7]==0x00) {
printf("SYS_connect_l2cap\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  psm %04x\n",event[14] | (event[15]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x16 && event[7]==0x00) {
printf("SYS_connect_l2cap_ok\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  connection_handle %04x\n",event[14] | (event[15]<<8));
printf("  psm %04x\n",event[16] | (event[17]<<8));
printf("  local_cid %04x\n",event[18] | (event[19]<<8));
printf("  remote_cid %04x\n",event[20] | (event[21]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x17 && event[7]==0x00) {
printf("SYS_connect_l2cap_fail\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  psm %04x\n",event[14] | (event[15]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x18 && event[7]==0x00) {
printf("SYS_l2cap_disconnected\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  local_cid %04x\n",event[14] | (event[15]<<8));
printf("  remote_cid %04x\n",event[16] | (event[17]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x19 && event[7]==0x00) {
printf("SYS_disconnect_l2cap\n");
printf("  address %02x:%02x:%02x:%02x:%02x:%02x\n",event[8],event[9],event[10],event[11],event[12],event[13]);
printf("  local_cid %04x\n",event[14] | (event[15]<<8));
printf("  remote_cid %04x\n",event[16] | (event[17]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x1e && event[7]==0x00) {
printf("SYS_local_channel_dealloced\n");
printf("  local_cid %04x\n",event[8] | (event[9]<<8));
return;
}
if (event[4]==0x03 && event[5]==0x00 && event[6]==0x10 && event[7]==0x00) {
printf("SYS_l2cap_frame\n");
printf("  connection_handle %04x\n",event[8] | (event[9]<<8));
printf("  l2cap_length %04x\n",event[10] | (event[11]<<8));
printf("  l2cap_channel %04x\n",event[12] | (event[13]<<8));
printf("  data %02x\n",event[14]);
return;
}
}
#line 321 "/home/dodo/btstack/src/event.u"

