#line 424 "/home/dodo/btstack/db/gen_db.u"

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#line 39 "/home/dodo/btstack/db/gen_db.u"

typedef struct key
{
  struct key *prev, *next;
  struct key *child, *parent;
  uint8_t len;
  uint8_t number;
  uint8_t value[8];
  char *name;
  char *keyp, *datap;
} dbcol_t;

#line 122 "/home/dodo/btstack/db/gen_db.u"

dbcol_t top= { &top, &top };

#line 328 "/home/dodo/btstack/db/gen_db.u"

int rw, body;

#line 605 "/home/dodo/btstack/db/gen_db.u"

static char lib_code[]=
#line 32 "gen_db.c"
"\n"
"#include <stdio.h>\n"
"#include <stdlib.h>\n"
"#include <string.h>\n"
"#include <db.h>\n"
"\n"
"\n"
"char* db_init(const char *fn);\n"
"void db_close();\n"
"static int dbget(DBT*key, DBT *val);\n"
"static int dbput(DBT*key, DBT *val);\n"
"static DB *dbp;\n"
"static char emsg[2000];\n"
"\n"
"char* db_init(const char *fn)\n"
"{\n"
"  int R;\n"
"  R= db_create(&dbp, NULL,0);\n"
"  if (R)\n"
"  {\n"
"    dbp= NULL;\n"
"    sprintf(emsg,\042db_create: %s\042, db_strerror(R));\n"
"    return emsg;\n"
"  }\n"
"\n"
"  R= dbp->open(dbp, NULL, fn, NULL, DB_BTREE, DB_CREATE, 0664);\n"
"  if (R)\n"
"  {\n"
"    sprintf(emsg,\042db-open(%s) %s\042, fn, db_strerror(R));\n"
"    dbp= NULL; // FIXME: we should \047uncreate\047 the pointer somehow\n"
"    return emsg;\n"
"  }\n"
"\n"
"  atexit(db_close);\n"
"  return NULL;\n"
"}\n"
"\n"
"static int dbget(DBT*key, DBT *val)\n"
"{\n"
"  return dbp->get(dbp, NULL, key, val, 0);\n"
"}\n"
"\n"
"static int dbput(DBT*key, DBT *val)\n"
"{\n"
"  return dbp->put(dbp, NULL, key, val, 0);\n"
"}\n"
"\n"
"void db_close()\n"
"{\n"
"  if (dbp) dbp->close(dbp,0);\n"
"}\n"
"\n"
"\n"

#line 610 "/home/dodo/btstack/db/gen_db.u"
;
static char lib_hdr[]= 
#line 89 "gen_db.c"
"\n"
"char* db_init(const char *fn);\n"
"void db_close();\n"
"\n"

#line 615 "/home/dodo/btstack/db/gen_db.u"
;

#line 97 "gen_db.c"

void add_key(dbcol_t* parent,char *name,char *keyp, char *datap);
dbcol_t *add_word(dbcol_t *node, char *name);
dbcol_t *new_node();
void add(char* name,char *kdecl,char *ddecl);
void enum_col(dbcol_t *key);
char *mkstr(char *begin,char *end);
void parse_kd(char *kd,char **key,char **data);
int print_proto_key(char *key,int kno);
int parse_type(char *key, int *kt, int *ks);
int print_proto_data_put(char *ddec,int dno);
int print_proto_data_get(char *ddec,int dno);
void print_proto(dbcol_t *K);
void iterate_leaf(dbcol_t *K, void (*func)(dbcol_t*));
void do_all_leaf(void (*func)(dbcol_t*));
void print_name(dbcol_t *K);
int main(int argc,char **argv);
int decl_size(char *decl);
void fill_in_key(dbcol_t *K);
void put_data(dbcol_t *K);
void print_put(dbcol_t *K);
void print_decls(dbcol_t *K);
void get_data(dbcol_t *K);
void print_get(dbcol_t *K);
static void shift_argv(int *argc,char **argv);
#line 71 "/home/dodo/btstack/db/gen_db.u"

void add_key(dbcol_t* parent,char *name,char *keyp, char *datap)
{
  char *part, *end;
  dbcol_t *node;
  end= strchr(name,'.');
  if (!end) end= name+strlen(name);
  part= mkstr(name, end);

  node= add_word(parent, part);
  if (end[0]=='.') add_key(node, end+1,keyp,datap);
  else
  {
    node->keyp= keyp;
    node->datap= datap;
  }
}

dbcol_t *add_word(dbcol_t *node, char *name)
{
  dbcol_t *K;
  if (node->child)
  {
   for(K=node->child->next;K!=node->child;K=K->next)
       if (!strcmp(K->name, name))
         return K;
  }
  if (!node->child)
    node->child= new_node();
  K= new_node();
  K->name= name;
  K->prev= node->child->prev;
  K->next= node->child;
  K->parent= node;
  node->child->prev->next= K; 
  node->child->prev= K;
  return K;
}

dbcol_t *new_node()
{
  dbcol_t *K;
  K= calloc(1,sizeof(*K));
  K->prev= K->next= K;
  return K;
}

#line 130 "/home/dodo/btstack/db/gen_db.u"

void add(char* name,char *kdecl,char *ddecl)
{
  add_key(&top, name, kdecl, ddecl);
}

#line 141 "/home/dodo/btstack/db/gen_db.u"

void enum_col(dbcol_t *key)
{
  uint8_t N=0;
  dbcol_t *K;
  for(K=key;K!=key->parent->child;K=K->next)
  {
    K->number= N++;
    K->len= K->parent->len+1;
    memcpy(K->value, K->parent->value, K->len-1);
    K->value[K->len-1]= K->number;
    K->value[0] &= ~(7<<5);
    K->value[0] |= K->len << 5;
    if (K->child)
      enum_col(K->child->next);
  }
}

#line 164 "/home/dodo/btstack/db/gen_db.u"

char *mkstr(char *begin,char *end)
{
  char *R;
  int L= end-begin;
  R= malloc(L+1);
  memcpy(R, begin, L);
  R[L]= 0;
  return R;
}

void parse_kd(char *kd,char **key,char **data)
{
  char *ke;
  ke= strchr(kd, '.');
  if (!ke) {
     *key= strdup(kd);
     *data= NULL;
  } else {
     *key= mkstr(kd, ke);
     *data= mkstr(ke+1, ke+strlen(ke));
  }
}

#line 200 "/home/dodo/btstack/db/gen_db.u"

int print_proto_key(char *key,int kno)
{
  int R;
  int kt, ks;
  R= parse_type(key, &kt, &ks);

  switch(kt)
  {
    case 'i': printf("uint%d_t k%d", ks*8, kno); break;
    case 'a': printf("uint8_t *k%d", kno); break;
  }
 
  return R;
}

#line 226 "/home/dodo/btstack/db/gen_db.u"

int parse_type(char *key, int *kt, int *ks)
{
  int sz;
  char *okey;

  *kt= 0;

  switch(key[0])
  {
  case 0: return 0;
  case 'b': *kt= 'i'; *ks= 1; return 1;
  case 'w': *kt= 'i'; *ks= 2; return 1;
  case 'd': *kt= 'i'; *ks= 4; return 1;
  case 'q': *kt= 'i'; *ks= 8; return 1;
  case 'a': *kt= 'a'; break;
  }

  okey= key;
  sz= 0;
  key++;
  while(isdigit(key[0]))
  {
    sz= sz*10 + key[0]-'0';
    key++;
  }
  *ks= sz;
  return key-okey;
}

#line 261 "/home/dodo/btstack/db/gen_db.u"

int print_proto_data_put(char *ddec,int dno)
{
  int R;
  int kt,ks;

  R= parse_type(ddec, &kt, &ks);
  switch(kt)
  {
  case 'i': printf("uint%d_t d%d", ks*8, dno); break;
  case 'a': printf("uint8_t *d%d", dno); break;
  }
  return R;
}

int print_proto_data_get(char *ddec,int dno)
{
  int R;
  int kt,ks;

  R= parse_type(ddec, &kt, &ks);
  switch(kt)
  {
  case 'i': printf("uint%d_t *d%d", ks*8, dno); break;
  case 'a': printf("uint8_t *d%d", dno); break;
  }
  return R;
}

#line 294 "/home/dodo/btstack/db/gen_db.u"

void print_proto(dbcol_t *K)
{
  int kno, dno;
  char *S;

  printf("int %s_",rw ? "dp" : "dg" ); print_name(K); 
  printf("(");
  for(S=K->keyp,kno=0;S[0];kno++)
  {
    if (kno) printf(",");
    S+= print_proto_key( S, kno );
  } 

  for(S=K->datap,dno=0;S[0];dno++)
  {
    if (kno+dno) printf(",");
    if (rw)
      S+= print_proto_data_put( S, dno );
    else
      S+= print_proto_data_get( S, dno );
  } 

  printf(")");
  if (body) printf("\n");
  else printf(";\n");
}

#line 335 "/home/dodo/btstack/db/gen_db.u"

void iterate_leaf(dbcol_t *K, void (*func)(dbcol_t*))
{
  if (K->keyp || K->datap)
   (*func)(K);
  if (K->child)
  {
    dbcol_t *C;
    for(C=K->child->next;C!=K->child;C=C->next)
      iterate_leaf(C, func);
  }
}

void do_all_leaf(void (*func)(dbcol_t*))
{
  iterate_leaf(&top, func);
}

#line 358 "/home/dodo/btstack/db/gen_db.u"

void print_name(dbcol_t *K)
{
  if (K->parent!=&top)
    { print_name(K->parent); printf("_"); }
  printf("%s", K->name);
}

#line 370 "/home/dodo/btstack/db/gen_db.u"

int main(int argc,char **argv)
{
  char key[100], decl[100];
  char g[200];
  while(fgets(g,2000,stdin))
  {
   char *Z;
   char *ks, *ds;
   for(Z=g;Z[0];Z++)
      if (Z[0]=='#') { Z[0]= 0; Z--; }
    if (sscanf(g,"%s%s",key,decl)!=2) continue;
    parse_kd(decl, &ks, &ds);
    add(key, ks, ds);
  }

  if (!top.child) return 0;
  enum_col(top.child->next);

  int print_lib= 0;
  
  while(argc>1) 
  {
     if (!strcmp(argv[1],"lib"))
     {
       print_lib= 1;
       shift_argv(&argc,argv);
       continue;
     }
     if (!strcmp(argv[1],"header"))
     {
       shift_argv(&argc,argv);
       if (print_lib) puts(lib_hdr);
       rw= 0; body= 0; do_all_leaf(print_proto);
       rw= 1; body= 0; do_all_leaf(print_proto);
       continue;
     }
     if (!strcmp(argv[1], "source")) {
       shift_argv(&argc,argv);
       if (print_lib) puts(lib_code);
       do_all_leaf(print_put);
       do_all_leaf(print_get);
       continue;
     }
     fprintf(stderr,"usage: %s [lib] (header|source)\n", argv[0]);
     exit(1);
   }
  return 0;
}

#line 443 "/home/dodo/btstack/db/gen_db.u"

int decl_size(char *decl)
{
  int kt,ks;
  int R;
  R= 0;
  while(decl[0])
  {
    decl+= parse_type(decl, &kt,&ks);
    R+= ks;
  }
  return R;
}

#line 461 "/home/dodo/btstack/db/gen_db.u"

void fill_in_key(dbcol_t *K)
{
  int kno;
  int o,i;
  char *S;
  int kt,ks;
  o= 0;
  for(i=0;i<K->len;i++,o++)
    printf("  kbuf[%d]= %d;\n", o, K->value[i]);
  
  S= K->keyp;
  kno= 0;
  while(S[0])
  {
    S+= parse_type(S, &kt, &ks);
    switch(kt)
    {
    case 'i': 
       if (ks==1)
         printf("  kbuf[%d]= k%d;\n", o, kno);
       else
         printf("  memcpy(kbuf+%d, &k%d, %d);\n", o, kno, ks);
       break;
    case 'a': printf("  memcpy(kbuf+%d, k%d, %d);\n", o, kno, ks); break;
    }
    o+= ks;
    kno++;
  }
}


void put_data(dbcol_t *K)
{
  int kt, ks;
  char *S;
  int dno;
  int o;

  S= K->datap;
  dno= 0; o= 0;
  while(S[0])
  {
    S+= parse_type(S, &kt, &ks);
    switch(kt)
    {
    case 'i': 
      if (ks==1)
        printf("  dbuf[%d]= d%d;\n", o, dno);
      else
        printf("  memcpy(dbuf+%d, &d%d, %d);\n", o, dno, ks);
      break;
    case 'a': printf("  memcpy(dbuf+%d, d%d, %d);\n", o, dno, ks); break;
    }
    o+= ks;
    dno++;
  }
}

#line 524 "/home/dodo/btstack/db/gen_db.u"

void print_put(dbcol_t *K)
{
  rw= 1; body= 1; print_proto(K);

  printf("{\n");
  print_decls(K);
  fill_in_key(K);
  put_data(K);
  printf("  return dbput(&key,&val);\n"); 
  printf("}\n");
}

void print_decls(dbcol_t *K)
{
  int ds, ks;
  ks= decl_size(K->keyp);
  ds= decl_size(K->datap);
  printf("  uint8_t kbuf[%d];\n", ks+K->len);
  printf("  uint8_t dbuf[%d];\n", ds);
  printf("  DBT key,val;\n");
  printf("  if (!dbp) return 1;\n");
  printf("  memset(&key,0,sizeof(key)); key.data= kbuf; key.size= %d;\n",
               ks+K->len);
  printf("  memset(&val,0,sizeof(val)); val.data= dbuf; val.size= %d;\n",
               ds);
}

#line 557 "/home/dodo/btstack/db/gen_db.u"

void get_data(dbcol_t *K)
{
  int kt, ks;
  char *S;
  int dno;
  int o;

  S= K->datap;
  dno= 0; o= 0;
  while(S[0])
  {
    S+= parse_type(S, &kt, &ks);
    switch(kt)
    {
    case 'i': 
     if (ks==1)
       printf("  *d%d= dbuf[%d];\n", dno, o);
     else
       printf("  memcpy(d%d, dbuf+%d,%d);\n", dno, o,ks);
     break;
    case 'a': printf("  memcpy(d%d, dbuf+%d,%d);\n", dno, o,ks); break;
    }
    o+= ks;
    dno++;
  }
}

void print_get(dbcol_t *K)
{
  rw= 0; body= 1; print_proto(K);

  printf("{\n");
  printf("  int R;\n");
  print_decls(K);
  fill_in_key(K);
  printf("  R= dbget(&key,&val);\n"); 
  printf("  if (R) return R;\n");
  get_data(K);
  printf("  return 0;\n");
  printf("}\n");
}

#line 679 "/home/dodo/btstack/db/gen_db.u"

static void shift_argv(int *argc,char **argv)
{
  int i;
  for(i=1;i<*argc-1;i++)
     argv[i]= argv[i+1];
  (*argc)--;
}

#line 436 "/home/dodo/btstack/db/gen_db.u"

