#line 698 "/home/dodo/btstack/model/gen_mask.u"

#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdlib.h>
#include "cmdline.h"
#include "strbuf.h"

#line 813 "/home/dodo/btstack/model/gen_mask.u"

#define  EBYTE(x)   { -1, 1, x, "b" },
#define  EWORD(x)   { -1, 2, x, "w" },
#define  EDWOR(x)   { -1, 4, x, "d" },
#define  EADDR(x)   { -1, 6, x, "A" },

#line 824 "/home/dodo/btstack/model/gen_mask.u"

#define EVENT(X) \
  field_t X[] = {
#define END \
     { 0, 0, 0 } \
  };

#line 7 "/home/dodo/btstack/model/hci.u"

#define OGF(X) ((X)<<10)
#define OCF(X) (X)

#line 16 "/home/dodo/btstack/model/hci.u"
#define HCI_EVENT(X) \
   { 4, 2, "#event_kind",       "w", 0x0002 }, \
   { 6, 1, "#hci_event",        "b", X }, \
   { 7, 1, "hci_evlen",         "b", },



#line 23 "/home/dodo/btstack/model/sysevents.u"

#define SYS_EVENT(X) \
   { 4, 2, "#event_kind",         "w", 0x0003 }, \
   { 6, 2, "#sys_event",          "w", X },

#line 5 "/home/dodo/btstack/model/l2cap.u"

#define L2CAP_COMMAND(X) \
   { 4, 2, "#event_kind",         "w", 0x0003 },  \
   { 6, 2, "#sys_event",          "w", 0x0010 },  \
   { 8, 2, "connection_handle",   "w", },  \
   {10, 2, "l2cap_length",        "w", },  \
   {12, 2, "#channel",            "w", 0x0001 },   \
   {14, 1, "#opcode",             "b", X }, \
   {15, 1, "identifier",          "b", }, \
   {16, 2, "cmd_data_length",     "w", }, 

#line 224 "/home/dodo/btstack/model/gen_mask.u"

enum { C_STORE, C_MATCH, C_MASK, C_EVENT, C_EOF, C_CODE,
      C_LABEL, C_WAIT, C_BUFFER, C_DATA_BUFFER, C_GET};

#line 58 "/home/dodo/btstack/model/gen_mask.u"

typedef struct {
   int offset;
   int size;
   char *name;
   char *type;
   uint32_t value;
} field_t;

typedef struct { char *name; field_t *fields; } event_t;

#line 70 "/home/dodo/btstack/model/gen_mask.u"

#line 259 "/home/dodo/btstack/model/hci.u"

   EVENT(HCI_remote_host_supported_features_notification)
     HCI_EVENT(0x3d)
     EADDR("bd_addr")
     EDWOR("featL")
     EDWOR("featH")
   END

   EVENT(HCI_remote_name_request_complete)
     HCI_EVENT(0x07)
     EBYTE("status")
     EADDR("bd_addr")
     { -1 , 248, "remote_name", "A" },
   END 

   EVENT(HCI_pin_code_request)
     HCI_EVENT(0x16)
     EADDR("bd_addr")
   END

   EVENT(HCI_link_key_request)
     HCI_EVENT(0x17)
     EADDR("bd_addr")
   END

   EVENT(HCI_link_key_notification)
     HCI_EVENT(0x18)
     EADDR("bd_addr")
     { -1, 16, "link_key", "A" },
     EBYTE("type")
   END

   EVENT(HCI_Connection_Request)
     HCI_EVENT(0x04)
     EADDR("bd_addr")
     { -1, 3, "class_of_device", "A" },
     EBYTE("link_type")
   END
#line 38 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_control_transfer_done)
           SYS_EVENT(0x0002)
           EDWOR("identifier")
           EDWOR("status")
        END
#line 58 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_transport_error)
           SYS_EVENT(0x0003)
           EWORD("kind")
           EDWOR("code")
           EBYTE("string_error")
        END
#line 89 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_acl_transfer_done)
           SYS_EVENT(0x0006)
           EDWOR("identifier")
           EDWOR("status")
        END
#line 111 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_socket_readable)
           SYS_EVENT(0x0007)
           EDWOR("fd")
        END
#line 125 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_socket_writable)
           SYS_EVENT(0x0008)
           EDWOR("fd")
        END
#line 139 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_socket_read_exception)
           SYS_EVENT(0x0009)
           EDWOR("fd")
        END
#line 160 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_socket_write_exception)
           SYS_EVENT(0x000a)
           EDWOR("fd")
        END
#line 200 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_connect_device)
           SYS_EVENT(0x0012)
           EADDR("address")
        END
#line 210 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_device_connected)
           SYS_EVENT(0x0013)
           EADDR("address")
           EWORD("connection_handle")
        END
#line 222 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_device_not_connected)
           SYS_EVENT(0x0014)
           EADDR("address")
        END
#line 234 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_connect_l2cap)
           SYS_EVENT(0x0015)
           EADDR("address")
           EWORD("psm")
        END
#line 246 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_connect_l2cap_ok)
           SYS_EVENT(0x0016)
           EADDR("address")
           EWORD("connection_handle")
           EWORD("psm")
           EWORD("local_cid")
           EWORD("remote_cid")
        END

#line 262 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_connect_l2cap_fail)
           SYS_EVENT(0x0017)
           EADDR("address")
           EWORD("psm")
        END
#line 275 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_l2cap_disconnected)
           SYS_EVENT(0x0018)
           EADDR("address")
           EWORD("local_cid")
           EWORD("remote_cid")
        END
#line 290 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_disconnect_l2cap)
           SYS_EVENT(0x0019)
           EADDR("address")
           EWORD("local_cid")
           EWORD("remote_cid")
        END
#line 312 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_local_channel_dealloced)
           SYS_EVENT(0x001e)
           EWORD("local_cid")
        END
#line 21 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_command_reject[] =
{
   L2CAP_COMMAND(0x01)
   {18, 2, "reason",              "b", },
   {20, 1, "data",                "b", },
   { 0, 0, 0 }
};

#line 36 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_connection_request[] =
{
   L2CAP_COMMAND(0x02)
   {18, 2, "psm",                 "w", },
   {20, 2, "source_cid",          "w", },
   { 0, 0, 0 }
};

#line 51 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_connection_response[] =
{
   L2CAP_COMMAND(0x03)
   {18, 2, "destination_cid",     "w", },
   {20, 2, "source_cid",          "w", },
   {22, 2, "result",              "w", },
   {24, 2, "status",              "w", },
   { 0, 0, 0 }
};

#line 68 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_configuration_request[] =
{
   L2CAP_COMMAND(0x04)
   {18, 2, "destination_cid",         "w", },
   {20, 2, "flags",                   "w", },
   {22, 1, "options",                 "b", },
   { 0, 0, 0 }
};

#line 178 "/home/dodo/btstack/model/sysevents.u"
        EVENT(SYS_l2cap_frame)
           SYS_EVENT(0x0010)
           EWORD("connection_handle")
           EWORD("l2cap_length")
           EWORD("l2cap_channel")
           EBYTE("data")
        END
#line 91 "/home/dodo/btstack/model/gen_mask.u"

field_t  HCI_connection_complete[]=
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x03 },
   { 8, 1, "status",              "b" },
   { 9, 2, "connection_handle",   "w" },
   { 11, 6, "bd_addr",            "A" },
   { 17, 1, "link_type",          "b" },
   { 18, 1, "encryption_enabled", "b" },
   { 0, 0, 0, }     
};

#line 24 "/home/dodo/btstack/model/hci.u"

field_t HCI_inquiry_result[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x02 },
   { 8, 1, "num_responses",       "b", },
   { 9, 1, "data",                "b", },
   { 0, 0, 0 }
};

field_t HCI_inquiry_result_with_rssi[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x22 },
   { 8, 1, "num_responses",       "b", },
   { 9, 1, "data",                "b", },
   { 0, 0, 0 }
};

field_t HCI_inquiry_complete[]= 
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x01 },
   { 8, 1, "status",              "b" },
   { 0, 0, 0 }
};

#line 58 "/home/dodo/btstack/model/hci.u"

field_t HCI_link_key_request_reply_command_complete[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0e },
   { 8, 1, "n_hci",               "b", },
   { 9, 2, "#opcode",             "w", OCF(0x0b) | OGF(0x01) },
   {11, 1, "status",              "b", },
   {12, 6, "bd_addr",             "A", },
   { 0, 0, 0 }
};

#line 76 "/home/dodo/btstack/model/hci.u"

field_t HCI_link_key_request_negative_reply_command_complete[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0e },
   { 8, 1, "n_hci",               "b", },
   { 9, 2, "#opcode",             "w", OCF(0x0C) | OGF(0x01) },
   {11, 1, "status",              "b", },
   {12, 6, "bd_addr",             "A", },
   { 0, 0, 0 }
};

#line 94 "/home/dodo/btstack/model/hci.u"

field_t HCI_command_status[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0f },
   { 8, 1, "status",              "b", },
   { 9, 1, "n_hci",               "b", },
   {10, 2, "opcode",              "w", },
   { 0, 0, 0 }
};

#line 112 "/home/dodo/btstack/model/hci.u"

field_t HCI_read_buffer_size_command_complete[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0e },
   { 8, 1, "n_hci",               "b", },
   { 9, 2, "#opcode",             "w", OCF(0x05) | OGF(0x04) },
   {11, 1, "status",              "b", },
   {12, 2, "acl_data_packet_length","w", },
   {14, 1, "synchronous_data_packet_length", "b" },
   {15, 2, "total_num_acl_data_packets", "w" },
   {17, 2, "total_num_synchronous_data_packets", "w" },
   { 0, 0, 0 }
};

#line 134 "/home/dodo/btstack/model/hci.u"

field_t ACL_packet[] =
{
   { 4, 2, "#event_kind",         "w", 0x0001 },
   { 6, 2, "connection_handle",   "w", },
   { 8, 2, "acl_length",          "w", },
   {10, 2, "l2cap_length",        "w", },
   {12, 2, "channel_id",          "w", },
   {14, 1, "l2cap_data",          "b", },
   { 0, 0, 0 }
};

#line 154 "/home/dodo/btstack/model/hci.u"

field_t HCI_number_of_completed_packets[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x13 },
   { 8, 1, "nresults",            "b", },
   { 0, 0, 0 }
};

#line 170 "/home/dodo/btstack/model/hci.u"

field_t HCI_max_slots_change[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x1b },
   { 8, 2, "connection_handle",       "w", },
   {10, 1, "lmp_max_slots",           "b", },
   { 0, 0, 0 }
};

#line 186 "/home/dodo/btstack/model/hci.u"

field_t HCI_disconnection_complete[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x05 },
   { 8, 1, "status",              "b", },
   { 9, 2, "connection_handle",   "w" },
   {11, 1, "reason",              "b" },
   { 0, 0, 0 }
};

#line 203 "/home/dodo/btstack/model/hci.u"

field_t HCI_Number_of_Completed_Packets[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x13 },
   { 8, 1, "Number_of_Handles",   "b", },
   { 9, 1, "data",                "b", },
   { 0, 0, 0 }
};

#line 224 "/home/dodo/btstack/model/hci.u"

field_t HCI_command_complete_with_status[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0e },
   { 8, 1, "n_hci",               "b", },
   { 9, 2, "opcode",              "w", },
   {11, 1, "status",              "b", },
   {12, 1, "data",                "b", },
   { 0, 0, 0 }
};

#line 242 "/home/dodo/btstack/model/hci.u"

field_t HCI_command_complete[] =
{
   { 4, 2, "#event_kind",         "w", 0x0002 },
   { 6, 1, "#hci_event",          "b", 0x0e },
   { 8, 1, "n_hci",               "b", },
   { 9, 2, "opcode",              "w", },
   {11, 1, "data",                "b", },
   { 0, 0, 0 }
};

#line 85 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_configuration_response[] =
{
   L2CAP_COMMAND(0x05)
   {18, 2, "source_cid",            "w", },
   {20, 2, "flags",                 "w", },
   {22, 2, "result",                "w", },
   {24, 1, "options",                "b", },
   { 0, 0, 0 }
};

#line 103 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_disconnection_request[] =
{
   L2CAP_COMMAND(0x06)
   {18, 2, "destination_cid",            "w", },
   {20, 2, "source_cid",                 "w", },
   { 0, 0, 0 }
};

#line 118 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_disconnection_response[] =
{
   L2CAP_COMMAND(0x07)
   {18, 2, "destination_cid",            "w", },
   {20, 2, "source_cid",                 "w", },
   { 0, 0, 0 }
};

#line 134 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_echo_request[] =
{
   L2CAP_COMMAND(0x08)
   {18, 1, "data",            "b", },
   { 0, 0, 0 }
};

#line 148 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_echo_response[] =
{
   L2CAP_COMMAND(0x09)
   {18, 1, "data",            "b", },
   { 0, 0, 0 }
};

#line 162 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_information_request[] =
{
   L2CAP_COMMAND(0x0a)   // FIXME: check this
   {18, 2, "info_type",            "w", },
   { 0, 0, 0 }
};

#line 176 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_information_response[] =
{
   L2CAP_COMMAND(0x0b)
   {18, 2, "info_type",            "w", },
   {20, 2, "result",               "w", },
   {22, 1, "data",                 "b", },
   { 0, 0, 0 }
};

#line 210 "/home/dodo/btstack/model/l2cap.u"

field_t L2CAP_unknown_command[] =
{
   { 4, 2, "#event_kind",         "w", 0x0003 },  
   { 6, 2, "#sys_event",          "w", 0x0010 },  
   { 8, 2, "connection_handle",   "w", },  
   {10, 2, "l2cap_length",        "w", },  
   {12, 2, "#channel",            "w", 0x0001 },   
   {14, 1, "opcode",              "b", },
   {15, 1, "identifier",          "b", }, 
   {16, 2, "cmd_data_length",     "w", }, 
   {18, 1, "data",                "b", },
   { 0, 0, 0 }
};

#line 74 "/home/dodo/btstack/model/gen_mask.u"

event_t events[]=
{
#line 105 "/home/dodo/btstack/model/gen_mask.u"

 { "HCI_connection_complete", HCI_connection_complete },

#line 52 "/home/dodo/btstack/model/hci.u"

 { "HCI_inquiry_result",            HCI_inquiry_result },
 { "HCI_inquiry_result_with_rssi",  HCI_inquiry_result_with_rssi },
 { "HCI_inquiry_complete",          HCI_inquiry_complete },

#line 71 "/home/dodo/btstack/model/hci.u"

 { "HCI_link_key_request_reply_command_complete", 
    HCI_link_key_request_reply_command_complete },

#line 89 "/home/dodo/btstack/model/hci.u"

 { "HCI_link_key_request_negative_reply_command_complete",
    HCI_link_key_request_negative_reply_command_complete },

#line 106 "/home/dodo/btstack/model/hci.u"

 { "HCI_command_status",            HCI_command_status },

#line 128 "/home/dodo/btstack/model/hci.u"

 { "HCI_read_buffer_size_command_complete",
    HCI_read_buffer_size_command_complete },


#line 147 "/home/dodo/btstack/model/hci.u"

 { "ACL_packet",            ACL_packet },

#line 164 "/home/dodo/btstack/model/hci.u"

 { "HCI_number_of_completed_packets",
    HCI_number_of_completed_packets },


#line 181 "/home/dodo/btstack/model/hci.u"

 { "HCI_max_slots_change",            HCI_max_slots_change },


#line 198 "/home/dodo/btstack/model/hci.u"

 { "HCI_disconnection_complete",            HCI_disconnection_complete },


#line 214 "/home/dodo/btstack/model/hci.u"

 { "HCI_Number_of_Completed_Packets",
   HCI_Number_of_Completed_Packets },

#line 237 "/home/dodo/btstack/model/hci.u"

 { "HCI_command_complete_with_status",
    HCI_command_complete_with_status },

#line 254 "/home/dodo/btstack/model/hci.u"

 { "HCI_command_complete",
    HCI_command_complete },

#line 31 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_command_reject", 
   L2CAP_command_reject },

#line 46 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_connection_request", 
   L2CAP_connection_request },

#line 63 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_connection_response", 
   L2CAP_connection_response },

#line 79 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_configuration_request", 
   L2CAP_configuration_request },


#line 97 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_configuration_response", 
   L2CAP_configuration_response },


#line 113 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_disconnection_request", 
   L2CAP_disconnection_request },

#line 128 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_disconnection_response", 
   L2CAP_disconnection_response },


#line 143 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_echo_request", 
   L2CAP_echo_request },

#line 157 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_echo_response", 
   L2CAP_echo_response },

#line 171 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_information_request", 
   L2CAP_information_request },

#line 187 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_information_response", 
   L2CAP_information_response },

#line 226 "/home/dodo/btstack/model/l2cap.u"

 { "L2CAP_unknown_command", 
   L2CAP_unknown_command },

#line 657 "gen_mask.c"
{"HCI_remote_host_supported_features_notification", HCI_remote_host_supported_features_notification},
{"HCI_remote_name_request_complete", HCI_remote_name_request_complete},
{"HCI_pin_code_request", HCI_pin_code_request},
{"HCI_link_key_request", HCI_link_key_request},
{"HCI_link_key_notification", HCI_link_key_notification},
{"HCI_Connection_Request", HCI_Connection_Request},
{"SYS_control_transfer_done", SYS_control_transfer_done},
{"SYS_transport_error", SYS_transport_error},
{"SYS_acl_transfer_done", SYS_acl_transfer_done},
{"SYS_socket_readable", SYS_socket_readable},
{"SYS_socket_writable", SYS_socket_writable},
{"SYS_socket_read_exception", SYS_socket_read_exception},
{"SYS_socket_write_exception", SYS_socket_write_exception},
{"SYS_connect_device", SYS_connect_device},
{"SYS_device_connected", SYS_device_connected},
{"SYS_device_not_connected", SYS_device_not_connected},
{"SYS_connect_l2cap", SYS_connect_l2cap},
{"SYS_connect_l2cap_ok", SYS_connect_l2cap_ok},
{"SYS_connect_l2cap_fail", SYS_connect_l2cap_fail},
{"SYS_l2cap_disconnected", SYS_l2cap_disconnected},
{"SYS_disconnect_l2cap", SYS_disconnect_l2cap},
{"SYS_local_channel_dealloced", SYS_local_channel_dealloced},
{"SYS_l2cap_frame", SYS_l2cap_frame},
#line 83 "/home/dodo/btstack/model/gen_mask.u"
   { 0 }
};

#line 336 "/home/dodo/btstack/model/gen_mask.u"

int error_source= -1;
#line 343 "/home/dodo/btstack/model/gen_mask.u"
event_t *def;

#line 430 "/home/dodo/btstack/model/gen_mask.u"
  static int last_return = 1;
#line 492 "/home/dodo/btstack/model/gen_mask.u"
int have_mask;

#line 500 "/home/dodo/btstack/model/gen_mask.u"


char* result[1024];
int n_result;


#line 578 "/home/dodo/btstack/model/gen_mask.u"

strbuf_t *dataxfr;

#line 621 "/home/dodo/btstack/model/gen_mask.u"

int n_stores;
char* stores[100];

#line 695 "/home/dodo/btstack/model/gen_mask.u"


#line 740 "/home/dodo/btstack/model/gen_mask.u"

 strbuf_t *code;
 int mode;

#line 771 "/home/dodo/btstack/model/gen_mask.u"

char *mid_label, *wait_inst, *buffer_name,*data_buffer_name;

#line 723 "gen_mask.c"

void match_field(char *name, char *value);
int ispc(uint32_t K);
int get_command(char *arg1,char *arg2);
void begin_event(char *name);
void output_model_defined_matches(field_t *fields);
void emit_match_i(uint32_t offset, uint32_t value);
void end_event();
void emit_stores();
void emit_return();
void end_mask();
void begin_mask(char *name);
void match_user_constant(field_t *field, char *value);
void emit_match_s(uint32_t offset, char *value);
void match_variable(field_t *field, char *value);
char *array_ref(int index,char *value);
char *byte(int index,char *value);
void store_field(char *name, char *idx);
void get_field(char *name, char *var) ;
field_t *find_field(char *name);
void get_rest(char *dest,char **R);
void emit_return_zero();
void record_code();
void fix_event_offsets();
void fix_offsets(field_t *F);
void print_event_printer(event_t *e);
void print_event_printers();
void print_event_defs();
void print_event_def(char *name, field_t *F);
#line 510 "/home/dodo/btstack/model/gen_mask.u"

void match_field(char *name, char *value)
{
  int i;
  field_t *field;

  field= find_field(name);

  while(ispc(*value)) value++;


  if (!field)
     exit(fprintf(stderr,"can't find field %s in event %s\n"
                         "unable to set value %s\n",
                             name, def->name, value));

  if (value[0]!='$') {
    match_user_constant(field, value);
    return ;
  }
  value++;

  match_variable(field, value);
}

#line 112 "/home/dodo/btstack/model/gen_mask.u"

int ispc(uint32_t K)
{
  if (K<=32 || K==127) return 1; return 0;
}

int get_command(char *arg1,char *arg2)
{
  uint8_t g[2000];
  char **K;
  int err;
  int i;
again:
  if (!fgets(g,1999, stdin)) return C_EOF;

  for(i=0;g[i];i++)
    if (!ispc(g[i]))
    {
      if (g[i]=='#') goto again;
    }
  K= parse_cmd_line(g, &err);
  
  if (!K) 
   {
     if (err==-1) goto again;
     fprintf(stderr,"error in gen_mask command at char %d\n", err);
     fprintf(stderr,"%s", g);
     fprintf(stderr,"%*s\n", err, "^");
     exit(1);
   }

  if (!strcmp(K[0],"mask"))
  {
    return C_MASK;
  }
  if (!strcmp(K[0],"label"))
  {
    if (!K[1]) 
     exit(fprintf(stderr,"LABEL command needs an argument\n"));
    strcpy(arg1,K[1]);
    return C_LABEL;
  }
  if (!strcmp(K[0],"wait"))
  {
    if (!K[1]) 
     exit(fprintf(stderr,"WAIT command needs an argument\n"));
    get_rest(arg1,K+1);
    return C_WAIT;
  }
                 // this is the buffer for the code, ie. T->mask
  if (!strcmp(K[0],"buffer"))
  {
    if (!K[1]) 
     exit(fprintf(stderr,"BUFFER command needs an argument\n"));
    get_rest(arg1,K+1);
    return C_BUFFER;
  }
                 // this is the buffer for the actual event i.e. T->event
  if (!strcmp(K[0],"data_buffer"))
  {
    if (!K[1]) 
     exit(fprintf(stderr,"DATA_BUFFER command needs an argument\n"));
    get_rest(arg1,K+1);
    return C_DATA_BUFFER;
  }
  if (!strcmp(K[0],"event"))
  {
    if (!K[1]) 
     exit(fprintf(stderr,"EVENT command needs an argument\n"));
    strcpy(arg1,K[1]);
    return C_EVENT;
  }

  if (!strcmp(K[0],"M"))
  {
    if (!K[1] || !K[2]) 
     exit(fprintf(stderr,"MATCH command needs two arguments, at least\n"));
    strcpy(arg1,K[1]);
    get_rest(arg2,K+2);
    return C_MATCH;
  }

  if (!strcmp(K[0],"S"))
  {
    if (!K[1] || !K[2]) 
     exit(fprintf(stderr,"STORE command needs two arguments, at least\n"));
    strcpy(arg1,K[1]);
    get_rest(arg2,K+2);
    return C_STORE;
  }

  if (!strcmp(K[0], "G"))
  {
    if (!K[1] || !K[2]) 
     exit(fprintf(stderr,"GET command needs two arguments\n"));
    strcpy(arg1,K[1]);
    strcpy(arg2,K[2]);
    return C_GET;
  }
  if (!strcmp(K[0],"{%"))
  {
    return C_CODE;
  }
 
  exit(fprintf(stderr,"unknown gen_mask command\n%s",g));
  return C_EOF;
}

#line 301 "/home/dodo/btstack/model/gen_mask.u"

void begin_event(char *name)
{
  int i;
  event_t *D;
  char buf[2000];

  D= 0;
  for(i=0;events[i].name;i++)
    if (!strcmp(events[i].name,name))
    {
     D= events+i;
     break;
    }

  if (!D) exit(fprintf(stderr,"unknown event %s\n",name));
  
  def= D;
  error_source= n_result;
  result[n_result++]= strdup("DECL_ERROR");
  output_model_defined_matches(def->fields);

  sprintf(buf,"case %d:\n", last_return);
  strbuf_puts(code, buf);
     // we do this here because
     // we have get() code following immediately, we can't
     // wait until we get to emit_return()
}

#line 351 "/home/dodo/btstack/model/gen_mask.u"

void output_model_defined_matches(field_t *fields)
{
  while(fields[0].name)
  {
    uint16_t offset;
    uint32_t value;
    int i, sz;
    char buf[200];

    offset= fields[0].offset;
    value= fields[0].value;

    if (fields[0].name[0]!='#') { fields++; continue; }

    for(i=0;i<fields[0].size;i++)
    {
       emit_match_i( offset, value & 0xff);
       value >>= 8;
       offset++;
    }
    fields++;
  }
}

void emit_match_i(uint32_t offset, uint32_t value)
{
   char buf[2000];
   sprintf(buf,"(0x01<<24) | (0x%04x<<8) | (0x%02x),\n",
                 offset&0xffff, value & 0xff);
   result[n_result++]= strdup(buf);
}
#line 387 "/home/dodo/btstack/model/gen_mask.u"

void end_event()
{
  char buf[2000];
  emit_stores();
  if (n_result) strbuf_puts(code, "break;\n"); // we always have this now.
  if (n_result) emit_return();
  if (error_source!=-1) 
  {
    sprintf(buf,"(0x03<<24) | (0x%04x<<8), \n", n_result);
    result[error_source]= strdup(buf);
    error_source= -1;
  }
}
#line 406 "/home/dodo/btstack/model/gen_mask.u"

void emit_stores()
{
  int i;
  for(i=0;i<n_stores;i++)
    result[n_result++]= stores[i];
  n_stores= 0;
}

#line 420 "/home/dodo/btstack/model/gen_mask.u"

void emit_return()
{
  char buf[2000];
  sprintf(buf,"(0x02<<24) | (0x%02x), \n", last_return);
  result[n_result++]= strdup(buf);
  last_return= (last_return+1)&0xff;
}

#line 441 "/home/dodo/btstack/model/gen_mask.u"

void end_mask()
{
   int i;
   if (!have_mask) goto reset;

   emit_return_zero();

   printf("do {\n");
   printf("static const uint32_t _TPL[]= {\n");
   
   for(i=0;i<n_result;i++)
    printf("%s", result[i]);
   printf("};\n");

   printf("memcpy(%s, _TPL, sizeof(_TPL));\n",buffer_name);

   printf("%s", strbuf_collect(dataxfr));

   printf("} while(0);\n");

   if (mid_label) printf("%s:\n",mid_label);

   printf("switch(%s){\n", wait_inst);
   printf("%s", strbuf_collect(code));
   printf("}\n");

reset:
#line 750 "/home/dodo/btstack/model/gen_mask.u"
  code= strbuf_init();

#line 470 "/home/dodo/btstack/model/gen_mask.u"
   dataxfr= strbuf_init();
   n_stores= 0;
   n_result= 0;
   def= 0;
   last_return= 1;
   have_mask= 0;
}
#line 481 "/home/dodo/btstack/model/gen_mask.u"

void begin_mask(char *name)
{
   have_mask= 1;
   wait_inst= "wait_for_events_2(T)";
   mid_label= 0;
   buffer_name= "T->mask";
   data_buffer_name= "T->event";
}

#line 546 "/home/dodo/btstack/model/gen_mask.u"


void match_user_constant(field_t *field, char *value)
{
  int i;
  uint16_t offset;
  offset= field->offset;
  for(i=0;i<field->size;i++)
  {
     char buf[2000];
     sprintf(buf,"((%s)>>%d)", value,i);
     emit_match_s(offset, buf);
     offset++;
  }
}

void emit_match_s(uint32_t offset, char *value)
{
  char buf[2000];
  sprintf(buf,"(0x01<<24) | (0x%04x<<8) | %s,\n", offset, value);
  result[n_result++]= strdup(buf);
}


#line 582 "/home/dodo/btstack/model/gen_mask.u"

void match_variable(field_t *field, char *value)
{
  char *(*access)(int,char*);
  int i;
  char buf[2000];
  if (field->type[0]=='A') access= array_ref;
  else access= byte;
  for(i=0;i<field[0].size;i++)
  {
     sprintf(buf,"*(uint8_t*) (%s+%d)= %s;\n", buffer_name,
                                      n_result,
                                           (*access)(i,value));
     strbuf_puts(dataxfr, buf);
     emit_match_i( field->offset+i, 0x00 );
  }
}

char *array_ref(int index,char *value)
{
  char buf[2000];
  sprintf(buf,"(%s)[%d]", value,index);
  return strdup(buf);
}

char *byte(int index,char *value)
{
  char buf[2000];
  sprintf(buf,"((%s)>>%d)", value,index*8);
  return strdup(buf);
}

#line 626 "/home/dodo/btstack/model/gen_mask.u"

void store_field(char *name, char *idx)
{
  field_t *field;
  char buf[2000];

  field= find_field(name);

  if (!field)
    exit(fprintf(stderr,"can't find field %s in event %s. can't store into "
                         "index %s\n", name, def->name, idx));

  sprintf(buf,"(0x04<<24) | (0x%04x<<8) | (0x%02x),\n",
                  field->offset, atoi(idx));
  
  stores[n_stores++]= strdup(buf);
}

void get_field(char *name, char *var) {
  field_t *field;
  char buf[2000];

  field= find_field(name);

  if (!field)
    exit(fprintf(stderr,"can't find field %s in event %s. can't store into "
                         "variable %s\n", name, def->name, var));

  switch(field->type[0])
  {
  case 'A':
    sprintf(buf,"memcpy(%s, %s+%d, %d);\n", var, data_buffer_name,
                                            field->offset, field->size);
    break;
  case 'b':
    sprintf(buf,"%s= %s[%d];\n", var, data_buffer_name, field->offset);
    break;
  case 'w':
    sprintf(buf,"%s= %s[%d] | (%s[%d]<<8);\n", var,
                 data_buffer_name, field->offset,
                 data_buffer_name, field->offset+1);
    break;
  case 'd':
    sprintf(buf,"%s= %s[%d] | (%s[%d]<<8) | (%s[%d]<<16) | (%s[%d]<<24);\n",
                 var,
                 data_buffer_name, field->offset,
                 data_buffer_name, field->offset+1,
                 data_buffer_name, field->offset+2,
                 data_buffer_name, field->offset+3);
  }
  strbuf_puts(code, buf);
}

field_t *find_field(char *name)
{
  int i;

  for(i=0;def->fields[i].name;i++)
    if (!strcmp(def->fields[i].name,name))
      return def->fields+i; 

  return 0;
}


#line 720 "/home/dodo/btstack/model/gen_mask.u"

void get_rest(char *dest,char **R)
{
  int i;
  dest[0]= 0;
  for(i=0;R[i];i++) {
    strcat(dest," ");
    strcat(dest,R[i]);
  }
}

void emit_return_zero()
{
  result[n_result++]= strdup("(0x02<<24)  | (0),\n");
}

#line 753 "/home/dodo/btstack/model/gen_mask.u"

void record_code()
{
  char buf[2000];
  while(fgets(buf,1999,stdin))
  {
    int i;
    for(i=0;buf[i];i++)
     if (!ispc(buf[i])) break;
    if (buf[i]=='%' && buf[i+1]=='}')
      return ;
    strbuf_puts(code, buf);
  }
}

#line 784 "/home/dodo/btstack/model/gen_mask.u"

void fix_event_offsets()
{
  int i;
  for(i=0;events[i].name;i++)
    fix_offsets(events[i].fields);
}

void fix_offsets(field_t *F)
{
  int last_offset= 0, last_size= 0;
  while(F->name)
  {
    if (F->offset<0)
     { F->offset= last_offset+last_size; }
    last_offset= F->offset;
    last_size= F->size;
    F++;
  }
}

#line 37 "/home/dodo/btstack/model/printer.u"

void print_event_printer(event_t *e)
{
  char *name;
  field_t *F;
  int first= 0;
  int i;
  name= e->name;

  printf("if (");

  for(F=e->fields;F->name;F++)
  {
    if (F->name[0]!='#') continue;

    if (first) printf(" && ");
    first= 1;

    switch(F->type[0])
    {
    case 'b': printf("event[%d]==0x%02x", F->offset, F->value&0xff); break;
    case 'w': printf("event[%d]==0x%02x && event[%d]==0x%02x", 
            F->offset, F->value&0xff, F->offset+1, F->value>>8); break;
    case 'd': printf("event[%d]==0x%02x && event[%d]==0x%02x "
                     "&& event[%d]=0x%02x && event[%d]==0x%02x", 
            F->offset,    F->value&0xff,
            F->offset+1, (F->value>>8)&0xff,
            F->offset+2, (F->value>>16)&0xff,
            F->offset+3, (F->value>>24)&0xff);
            break;
    }
  }
  printf(") {\n");

  printf("printf(\"%s\\n\");\n", e->name);
  
  for(F=e->fields;F->name;F++)
  {
    if (F->name[0]=='#') continue;
    printf("printf(\"  %s ", F->name);
    switch(F->type[0])
    {
    case 'b':
        printf("%%02x\\n\",event[%d]);\n", F->offset);
        break;
    case 'w':
        printf("%%04x\\n\",event[%d] | (event[%d]<<8));\n",
                     F->offset,F->offset+1); break;
    case 'd':
        printf("%%08x\\n\",event[%d] | (event[%d]<<8) | (event[%d]<<16) | (event[%d]<<24));\n",
                     F->offset,F->offset+1,F->offset+2,F->offset+3); break;
    case 'A':
        for(i=0;i<F->size;i++)
        {
          if (i) printf(":");
          printf("%%02x");
        }
        printf("\\n\"");
        for(i=0;i<F->size;i++)
          printf(",event[%d]", F->offset+i);
        printf(");\n");
        break;
    }
  }
  printf("return;\n}\n");
}


#line 117 "/home/dodo/btstack/model/printer.u"

void print_event_printers()
{
   event_t *e;
   printf("void print_event(uint8_t *event){\n");
   for(e=events;e->name;e++)
      print_event_printer(e);
   printf("}\n");
}


#line 13 "/home/dodo/btstack/model/defs.u"

void print_event_defs()
{
  int i;
  for(i=0;events[i].name;i++)
    if (!strncmp(events[i].name,"SYS_",4))
      print_event_def(events[i].name+4, events[i].fields);
}

void print_event_def(char *name, field_t *F)
{
  int i;
  for(i=0;F[i].name;i++)
    if (!strcmp(F[i].name,"#sys_event"))
    {
       printf("#define SYSTEM_%-40s 0x%04x\n",name, F[i].value);
       return ;
    }
}
#line 234 "/home/dodo/btstack/model/gen_mask.u"

int main(int argc,char **argv)
{
  char arg1[2000], arg2[2000];
  dataxfr= strbuf_init();
#line 745 "/home/dodo/btstack/model/gen_mask.u"
  code= strbuf_init();
  if (argc>1 && !strcmp(argv[1],"-c"))
    mode= 'C';

#line 806 "/home/dodo/btstack/model/gen_mask.u"

   fix_event_offsets();

#line 109 "/home/dodo/btstack/model/printer.u"

  if (argc>1 && !strcmp(argv[1],"-p"))
  {
     print_event_printers();
     return 0;
  }

#line 9 "/home/dodo/btstack/model/defs.u"

  if (argc>1 && !strcmp(argv[1],"-d")) { print_event_defs(); return 0; }

#line 240 "/home/dodo/btstack/model/gen_mask.u"
  while(1)
    switch(get_command(arg1,arg2))
    {
    case C_EOF:
       end_event();
       end_mask();
       return 0;
    case C_MASK: 
       end_event();
       end_mask();
       begin_mask(arg1);
       break;
    case C_BUFFER:
       if (!have_mask) exit(fprintf(stderr,"BUFFER command (%s) given outside "
                                            "a mask block. aborting.\n",arg1));
       buffer_name= strdup(arg1);
       break;
    case C_DATA_BUFFER:
       if (!have_mask) exit(fprintf(stderr,"DATA_BUFFER command (%s) given outside "
                                            "a mask block. aborting.\n",arg1));
       data_buffer_name= strdup(arg1);
       break;
    case C_LABEL:
       if (!have_mask) exit(fprintf(stderr,"label command (%s) given outside "
                                            "a mask block. aborting.\n",arg1));
       mid_label= strdup(arg1);
       break;
    case C_WAIT:
       if (!have_mask) exit(fprintf(stderr,"wait command (%s) given outside "
                                            "a mask block. aborting.\n",arg1));
       wait_inst= strdup(arg1);
       break;
    case C_EVENT:
       if (!have_mask) exit(fprintf(stderr,"event command (%s) given outside "
                                            "a mask block. aborting.\n",arg1));
       end_event();
       begin_event(arg1);
       break;
    case C_STORE: 
       if (!def) exit(fprintf(stderr,"store command (%s) given outside "
                                     "an event block. aborting.\n",arg1));
       store_field(arg1,arg2);
       break;
    case C_GET: 
       if (!def) exit(fprintf(stderr,"get command (%s) given outside "
                                     "an event block. aborting.\n",arg1));
       get_field(arg1,arg2);
       break;
    case C_MATCH:
       if (!def) exit(fprintf(stderr,"match command (%s) given outside "
                                     "an event block. aborting.\n",arg1));
       match_field(arg1,arg2);
       break;
    case C_CODE:
       record_code();
       break;
    }
  return 0;
}

#line 717 "/home/dodo/btstack/model/gen_mask.u"


