#include <stdint.h>
#include <stdlib.h>
#include "ptrfifo.h"


uint32_t *ptrfifo_new(int sz)
{
   uint32_t *buffer;
   
   buffer= malloc(sizeof(void*)*sz+4*sizeof(uint32_t));
   buffer[0]= 0;  // head
   buffer[1]= 0;  // len
   buffer[2]= sz; // size
   return buffer;
}

void **ptrfifo_data(uint32_t *fifo)
{
   return (void**) (fifo+4);
}

uint32_t* ptrfifo_put(uint32_t *buffer,void *data)
{
   void **d;
   d= ptrfifo_data(buffer);
   if (buffer[1]==buffer[2])
   {
      uint32_t* nb;
      void **nd; 
      int i;
      nb= ptrfifo_new(buffer[2]*2);
      nd= ptrfifo_data(nb);
      for(i=0;i<buffer[1];i++)
        nd[i]= d[(i+buffer[0])%buffer[2]];
      nb[1]= buffer[1];
      free(buffer);
      buffer= nb;
   }
   d[(buffer[0]+buffer[1])%buffer[2]]= data;
   buffer[1]++;
   return buffer;
}

void *ptrfifo_get(uint32_t *buffer)
{
   void *R;
   void **d;
   if (buffer[1]==0) return 0;
   d= ptrfifo_data(buffer);
   R= d[buffer[0]];
   buffer[0]= (buffer[0]+1)%buffer[2];
   buffer[1]--;
   return R;
}

int ptrfifo_empty(uint32_t *buffer)
{
   return buffer[1]==0;
}
