#line 97 "/home/dodo/btstack/src/resource.u"

#include <stdlib.h>
#include <stdint.h>
#include "ptrfifo.h"


#line 12 "/home/dodo/btstack/src/resource.u"

struct thread;
typedef struct resource resource_t;

#line 17 "/home/dodo/btstack/src/resource.u"

struct resource
{
  int value;
  uint32_t *waiting;
};

#line 21 "resource.c"

void resource_get(struct thread *T, resource_t *R);
void resource_set(resource_t *R, int value);
void resource_add(resource_t *R, int value);
resource_t* resource_init(int V);
#line 108 "/home/dodo/btstack/src/resource.u"

void thread_suspend(struct thread *T, int how);
void thread_wakeup(struct thread *T);

#line 29 "/home/dodo/btstack/src/resource.u"

void resource_get(struct thread *T, resource_t *R)
{
  if (R->value>0) { R->value--; return ; }
  ptrfifo_put(R->waiting, T);
  thread_suspend(T, 'L');
}


#line 43 "/home/dodo/btstack/src/resource.u"

void resource_set(resource_t *R, int value)
{
  while(value && !ptrfifo_empty(R->waiting))
  {
    struct thread *T;
    T= ptrfifo_get(R->waiting);
    thread_wakeup(T);
    value--;
  }
  R->value= value;
}

#line 61 "/home/dodo/btstack/src/resource.u"

void resource_add(resource_t *R, int value)
{
  resource_set(R, R->value+value);
}

#line 71 "/home/dodo/btstack/src/resource.u"

resource_t* resource_init(int V)
{
  resource_t *R;
  R= malloc(sizeof(*R));
  R->waiting= ptrfifo_new(10);
  R->value= V;
  return R;
}

#line 113 "/home/dodo/btstack/src/resource.u"

