#line 265 "/home/dodo/btstack/src/sdp-lib.u"

#line 7 "/home/dodo/btstack/src/sdp-lib.u"

typedef struct {
  int state;
  uint8_t *ibuf;
  uint32_t ibuflen,ibufsiz;
  uint8_t *obuf;
  uint32_t obuflen, obufsiz;
  socket_t *socket;
  int trans;
  char errstr[200];
} sdp_conn_t;

#line 301 "/home/dodo/btstack/src/sdp-lib.u"

typedef struct {
  awriter_t *wr;
  areader_t *rd;
  int error;
  char errstr[2000];
  socket_t *socket;
} ctrl_t;

#line 20 "/home/dodo/btstack/src/sdp-proto.u"

typedef struct sdp_prtl
{
   uint16_t uuid; // hmm, should I make it 128 bits??
   uint8_t *params;
   uint32_t paramslen;
   struct sdp_prtl *lower;
} sdp_protocol_t;

#line 6 "/home/dodo/btstack/src/avdtp-lib.u"

typedef struct {
  awriter_t *wr;
  areader_t *rd;
  socket_t *sock;
  int err;
  char errstr[2000];
  uint8_t addr[6];
} avdtp_conn_t;

#line 47 "sdp-lib.h"

uint32_t *sdp_service_list(sdp_conn_t *SC, int nsea, uint16_t *sea);
sdp_conn_t *sdp_connect(uint8_t *addr);
ctrl_t *ctrl_connect();
uint64_t *ctrl_device_list(ctrl_t *C,int inq);
uint64_t read_addr(uint8_t *B);
int write_addr(uint8_t *dest, uint64_t addr);
int ctrl_send(ctrl_t *C, uint8_t *buf, int len);
void print_addr(uint64_t addr);
int ctrl_recv(ctrl_t *C);
char *ctrl_device_name(ctrl_t *C, uint64_t addr);
void ctrl_close(ctrl_t *C);
int sdp_get_attribs(sdp_conn_t *S, uint32_t svc, ...);
sdp_protocol_t **sdp_protocol_descriptor_list
      (sdp_conn_t *S, uint32_t svc);
void print_proto_descs(sdp_protocol_t **P);
avdtp_conn_t *avdtp_open(uint8_t *addr);
int avdtp_discover_endpoints(avdtp_conn_t *A,uint8_t **R, uint32_t *L);
void avdtp_close(avdtp_conn_t *A);
int avdtp_get_capabilities(avdtp_conn_t *A, uint8_t reid,
                           uint8_t **R, uint32_t *L);
int avdtp_get_sbc_capabilities
     (avdtp_conn_t* A, uint8_t reid, uint8_t *oct0, uint8_t *oct1,
      uint8_t *min_bitpool, uint8_t *max_bitpool);
int send_packet(avdtp_conn_t *A, uint8_t *b, uint32_t l);
avdtp_conn_t *avdtp_open_sbc_stream
  (avdtp_conn_t *A,uint8_t reid, uint8_t leid,
   uint8_t oct0, uint8_t oct1, uint8_t min_bitpool, uint8_t max_bitpool);
#line 270 "/home/dodo/btstack/src/sdp-lib.u"

