#line 7 "/home/dodo/btstack/src/sdp-test.u"

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include "socket.h"
#include "aread.h"
#include "awrite.h"
#include "util.h"
#include "sdp-lib.h"

uint8_t phone_addr[6]= { 0xbc,0x1d,0x01,0x55,0x38,0x30 };

uint8_t hs_addr[6]= { 0x59,0x37,0x11,0x67,0x11,0x00 };


int check_avdtp(sdp_conn_t *S, uint32_t *svc)
{
  sdp_protocol_t **P;
  int i,j;
  for(j=0;svc[j];j++) {
    P= sdp_protocol_descriptor_list(S, svc[j]);
    for(i=0;P[i];i++)
      if (P[i]->uuid==0x0019) {
         printf("service %08x has AVDTP",svc[j]);
         return 1;
      }
     // FIXME: free the protocol list
  }
  return 0;
}


int main()
{
  sdp_conn_t *S;
  uint32_t *svc;
  int i;
  uint16_t sea[12];
  sdp_protocol_t **P;

  S= sdp_connect(hs_addr);

  if (S->state)
    exit(fprintf(stderr,"sdp-test(connect): %s\n", S->errstr));

  i= 0;
  // sea[i++]= 0x1002;
  sea[i++]= 0x110B;
  svc= sdp_service_list(S, i, sea);

  if (!svc) 
    exit(fprintf(stderr,"can't get service handle list\n"));

  printf("Service Handles\n");
  for(i=0;svc[i];i++)
     printf("  %08x\n",svc[i]);

  printf("getting protocol descriptor list\n");

  check_avdtp(S, svc);

  sdp_disconnect(S);
  printf("all done.\n");
  return 0;
}

