#line 5 "/home/dodo/btstack/src/usb-test.u"

#line 225 "/home/dodo/btstack/src/usb-test.u"

#include <stdint.h>
#include <stdlib.h>
#include <stdarg.h>
#include <signal.h>
#include <string.h>
#include <errno.h>
#include "event.h"
#include "util.h"
#include "socket.h"
#include "aread.h"
#include "awrite.h"
#include "comnames.h"
#include "channels.h"
#include "resource.h"

#line 6 "/home/dodo/btstack/src/usb.u"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <libusb-1.0/libusb.h>

#define uprintf printf

#line 76 "/home/dodo/btstack/src/threads.u"

#include "coth.h"

#line 258 "/home/dodo/btstack/src/poll.u"
#include <sys/poll.h>
#line 366 "/home/dodo/btstack/src/agent-control.u"

#include <sys/socket.h>
#include "socket.h"

#line 7 "/home/dodo/btstack/src/usb-test.u"

#line 15 "/home/dodo/btstack/src/threads.u"

typedef struct thread thread_t;

struct thread {
  int      state;
  coth_t*  self_ctx;
  uint8_t* event;
  int      match;

  uint32_t mask[256];
  uint8_t *edata[100];

};


#line 28 "/home/dodo/btstack/src/l2cap.u"

typedef struct {
  uint16_t id;
  uint8_t addr[6];
  int state;
  int n_packets,s_packets;
  uint8_t **packets;
  int total_received;
  int total_expected;
} connection_t;

#line 551 "/home/dodo/btstack/src/l2cap.u"

typedef struct {
  uint16_t local_cid, remote_cid, psm;
  uint32_t mtu;
  int state;
  int config;
  uint8_t expected_identifier;
} channel_t;

#line 19 "/home/dodo/btstack/src/device.u"

typedef struct device {
  struct device *next, *prev;
  uint8_t addr[6];

  uint8_t is_live;
  uint16_t clock_offset;

  uint8_t H_rssi;
  uint8_t rssi;

  uint8_t  H_acl_connection_handle;
  uint16_t ACL_connection_handle;
  uint8_t  ACL_encryption_enabled;
} device_t;

#line 7 "/home/dodo/btstack/src/controller.u"

typedef struct {
  uint8_t H_local_supported_features;
  uint64_t local_supported_features;

  uint8_t H_buffer_sizes;
  uint16_t max_acl_packet_len, max_sco_packet_len,
           num_acl_packets,    num_sco_packets;
  
} controller_t;

#line 6 "/home/dodo/btstack/src/hci-defs.u"

#define OGF(X)  ((X)<<10)
#define OCF(X)  (X)

#define HCI_EVENT_command_complete             0x0e
#define HCI_EVENT_command_status               0x0f
#define HCI_EVENT_inquiry_complete             0x01
#define HCI_EVENT_inquiry_result               0x02
#define HCI_EVENT_inquiry_result_with_rssi     0x22

#define HCI_COMMAND_inquiry                        (OCF(0x01) | OGF(0x01))
#define HCI_COMMAND_read_local_supported_features  (OCF(0x03) | OGF(0x04))
#define HCI_COMMAND_read_remote_name_request       (OCF(0x19) | OGF(0x01))

#line 123 "usb-test.c"

void print_hex(const char* field, uint8_t *data, int len);
void destroy_thread(thread_t *T);
void check_queued_events(thread_t *T);
void event_loop();
void interpret_error_code(const char *op,int code);
void controller_init(thread_t *T);
void test_thread(thread_t *T);
void local_cid_done(uint16_t cid);
static void sigint(int signo);
uint32_t vendor_id() ;
uint32_t product_id() ;
char *get_default_pin_code() ;
static void init_env();
static void figure_out_endpoints();
static void start_polling();
static void fill_and_submit_intr_xfr();
static void fill_and_submit_bulk_xfr();
static void intr_cb(struct libusb_transfer *xfr);
static void bulk_cb(struct libusb_transfer *xfr);
void init_threads();
int wait_for_events_2(thread_t *T);
static void control_cb(struct libusb_transfer* xfr);
uint8_t *hci_command_packet_for_usb
  (int opcode, uint8_t *param, size_t plen);
void check_for_hci_available(uint8_t *event);
const char *hci_error_code(uint32_t X);
void inquiry(thread_t *T);
void handle_acl_packet(uint8_t *acl_packet);
int l2cap_length(uint8_t *acl_packet);
uint32_t get_le16(uint8_t *K);
connection_t* create_connection(uint8_t *addr,uint32_t coha);
void send_echo_request(thread_t *T, uint32_t coha);
static void bulk_send_cb(struct libusb_transfer *xfr);
void cancel_packets(connection_t *C);
void assemble_frame(connection_t *C);
int put_le16(uint8_t *D, uint32_t V);
void l2cap_frame(uint8_t *buffer, int channel, const char *fmt, ...);
channel_t *find_channel_by_identifier
  (uint32_t identifier, channel_t **channels, int n_channels);
channel_t *find_channel_by_local_cid
   (uint32_t local_cid, channel_t **channels, int n_channels);
int check_command_identifier(char *op, channel_t *S, uint32_t local_cid);
channel_t* remove_channel(channel_t** channels, int n_channels, channel_t *S);
void handle_usb_fds() ;
static void add_libusb_fd(int fd, short events, void *arg);
static void remove_libusb_fd(int fd, void *arg);
void poll_init();
void client_control_thread
  (thread_t *T, socket_t *socket, uint64_t bclient_id);
int get_connect_params(thread_t *T, areader_t *ard,
                       uint8_t *addr, uint16_t *psm);
int control_connect(thread_t *T, uint8_t *addr, uint16_t psm,
                    uint16_t *Rcoha, uint16_t *Rlocal_cid,
                                     uint16_t *Rremote_cid);
static void send_connect_ok(awriter_t *wr);
void command_loop(thread_t *T, areader_t *rd, awriter_t *wr);
void send_device_list(awriter_t *wr);
void send_device_name(thread_t *T, uint8_t *addr, awriter_t *wr);
device_t *find_device_by_addr(uint8_t *addr);
char *bd_addr_to_str(uint8_t *addr);
void server_thread(thread_t *T);
void create_client_thread(void *func, socket_t *socket, int client_id);
static void send_link_key(thread_t *T, uint8_t *addr);
void read_local_supported_features(thread_t *T);
void read_buffer_size(thread_t *T);
int usb_init();
void usb_print_error(char *op, int code);
int usb_open();
thread_t *create_thread(void (*func)(thread_t *));
void event_dispatch(uint8_t *event);
int event_matches_thread(uint8_t *event, thread_t *T);
void thread_exit(thread_t *T);
void thread_suspend(thread_t *T, int how);
void thread_wakeup(thread_t *T);
int send_hci_command
  (thread_t *T,int opcode, uint8_t *param, size_t plen);
int send_hci_command_expect_status
  (thread_t *T,uint32_t opcode, uint8_t *param, size_t plen);
int send_hci_command_expect_complete
  (thread_t *T,uint32_t opcode, uint8_t *param, size_t plen,int has_status);
int send_l2cap_frame(thread_t *T,uint16_t coha,uint8_t *frame,int len);
 
void l2cap_buffer_monitor(thread_t *T);
void l2cap_signal_thread(thread_t *T, connection_t *C);
void poll_all();
void add_poll_fd(int fd, int how);
void remove_poll_fd(int fd);
void acl_connection_manager(thread_t *T);
int connect_device(thread_t *T,uint8_t *addr,uint16_t *coha);
int put_addr(uint8_t *D, uint8_t *A);
uint8_t* hci_command_complete_event_data(uint8_t *event);
void enable_simple_pairing(thread_t *T);
void print_supported_commands(thread_t *T);
device_t *get_device(uint8_t *bd_addr);
void pincode_thread(thread_t *T);
#line 219 "/home/dodo/btstack/src/usb-test.u"

uint8_t phone_addr[6]= { 0xbc,0x1d,0x01,0x55,0x38,0x30 };

#line 264 "/home/dodo/btstack/src/usb-test.u"

static uint32_t usb_vendor_id, usb_product_id;
static char *usb_pin_code;
int event_print_flag;

#line 18 "/home/dodo/btstack/src/usb.u"

static libusb_device_handle *device_handle;

#line 86 "/home/dodo/btstack/src/usb.u"

static int 
  hci_command_ep,
  hci_event_ep,
  acl_out_ep,
  acl_in_ep;


#line 192 "/home/dodo/btstack/src/usb.u"

static struct libusb_transfer *intr_xfr, *bulk_xfr;

#line 59 "/home/dodo/btstack/src/threads.u"

static thread_t** threads;
static int nthreads, sthreads;
static coth_t *main_coth;


#line 265 "/home/dodo/btstack/src/hci.u"

resource_t *hci_available_resource;

#line 127 "/home/dodo/btstack/src/inquiry.u"

resource_t *inquiry_lock;

#line 40 "/home/dodo/btstack/src/l2cap.u"
connection_t **connections;
int n_connections, s_connections;

#line 1136 "/home/dodo/btstack/src/l2cap.u"

  resource_t *acl_lock;

#line 1147 "/home/dodo/btstack/src/l2cap.u"

  resource_t *acl_buffers_resource;

#line 41 "/home/dodo/btstack/src/poll.u"

struct pollfd  poll_fds[1024];
int n_poll_fds;
int n_libusb_fds;

#line 36 "/home/dodo/btstack/src/device.u"

 device_t devices= { &devices, &devices };

#line 19 "/home/dodo/btstack/src/controller.u"

controller_t controller;

#line 51 "/home/dodo/btstack/src/usb-test.u"

void print_hex(const char* field, uint8_t *data, int len)
{
  int i;
  printf("%s: ",field);
  for(i=0;i<len;i++) {
   if (i) printf(":");
   printf("%02x",data[i]); 
  }
  printf("\n");
}

void destroy_thread(thread_t *T)
{
   coth_free(T->self_ctx);
   if (T->event) free(T->event);
   free(T);
}

void check_queued_events(thread_t *T)
{
  event_t *E;

  for_EVENTS(E)
    if (event_matches_thread(E->event,T))
    {
       event_dequeue(E);
       T->state= 'R';
       break;
    }
}

void event_loop()
{
  int i,j,have_runnable,start;
  thread_t *T;

 start= 0;

 while(nthreads)
 {
  local_cids_beat();

  for(j=0,i=0;i<nthreads;i++)
    if (threads[i]->state=='D')
    {
      destroy_thread(threads[i]);
    }
    else
    {
      threads[j]= threads[i];
      j++;
    }
  nthreads= j;
   
  if (!nthreads) return ;

  if (start>nthreads) start %= nthreads;

  have_runnable= 0;

  for(i=0;i<nthreads;i++)
  {
    T= threads[(i+start)%nthreads];
    if (T->state=='W') check_queued_events(T);
    if (T->state=='R') have_runnable= 1;
  }


  if (have_runnable)
  {
    int first= 1;
    for(i=0;i<nthreads;i++)
    {
       T= threads[(i+start+1)%nthreads];
       if (T->state=='R') 
         coth_switch(main_coth, T->self_ctx);
       if (first)
         start= i;
       first= 0;
    }
  }
  else 
  {
    poll_all();
  }
 }
}


void interpret_error_code(const char *op,int code)
{
  uint8_t *event;
  char strbuf[2000];
  int len,size,i;

  if (code==0) return ;

  fprintf(stderr,"%s: libusb error: %d %s\n",
           op, code, libusb_error_name(code)); 
  
  snprintf(strbuf, sizeof(strbuf),
          "%s: libusb error: %d %s\n",
           op, code, libusb_error_name(code)); 
  
  len= 2 + 2 + 4 + strlen(strbuf)+1;
  size= len + EVENT_HEADER_SIZE;

  event= malloc(size);
  event_set_size(event, size);
  event_set_length(event, len);
  event_set_code(event, EVENT_system);

  i= EVENT_HEADER_SIZE;
  event[i++]=  SYSTEM_transport_error & 0xff;
  event[i++]=  SYSTEM_transport_error >> 8;
  event[i++]=  TRANSPORT_ERROR_libusb & 0xff;
  event[i++]=  TRANSPORT_ERROR_libusb >> 8;
  event[i++]=  code & 0xff;
  event[i++]=  code >> 8;
  event[i++]=  code >> 16;
  event[i++]=  code >> 24;
  strcpy(event+i, strbuf);
  event_dispatch(event);
}

void controller_init(thread_t *T)
{
  printf("reading local supported features\n");
  read_local_supported_features(T);
  printf("reading buffer sizes\n");
  read_buffer_size(T);
  enable_simple_pairing(T);
  print_supported_commands(T);
  thread_exit(T);
}


void test_thread(thread_t *T)
{
#if 0
  device_t *D;
  uint16_t coha;
  D= get_device(phone_addr);
  if (!D->is_live)
    inquiry(T);
  if (!D->is_live)
    { printf("can't find remote device. exiting.\n"); goto done; }

  if (connect_device(T,D->addr,&coha))
    { printf("can't connect to device. exiting.\n"); goto done; }

  printf("Connect OK. coha= %04x\n",coha);

    // does it have SDP? 
  system_event(SYSTEM_connect_l2cap, "pw", 6, phone_addr, 0x01);

done:
  thread_exit(T);
#else

  server_thread(T);
#endif
  
}


#line 242 "/home/dodo/btstack/src/usb-test.u"

void local_cid_done(uint16_t cid)
{
  printf("local cid %04x is deallocated\n",cid);
  system_event(SYSTEM_local_channel_dealloced, "w", cid);
}

static void sigint(int signo)
{
  exit(1);
}

#line 258 "/home/dodo/btstack/src/usb-test.u"

uint32_t vendor_id() { return usb_vendor_id; }
uint32_t product_id() { return usb_product_id; }
char *get_default_pin_code() { return usb_pin_code; }

#line 270 "/home/dodo/btstack/src/usb-test.u"

static void init_env()
{
  char *v;
  v= getenv("USB_VENDOR_ID");
  if (!v) usb_vendor_id= 0x1caa;
  else usb_vendor_id= strtoul(v, NULL,0);
  v= getenv("USB_PRODUCT_ID");
  if (!v) usb_product_id= 0x0001;
  else usb_product_id= strtoul(v, NULL,0);
  v= getenv("BTH_PIN_CODE");
  if (!v) v= "0000";
  usb_pin_code= strdup(v);

  v= getenv("BTH_PRINT_EVENTS");
  if (v) event_print_flag= strtol(v,NULL,0);
}

#line 95 "/home/dodo/btstack/src/usb.u"

static void figure_out_endpoints()
{
  int i;
  struct libusb_config_descriptor *cd;
  struct libusb_interface_descriptor *id;
  struct libusb_endpoint_descriptor *ed;
  int n_endpoints;
  int R;

  R= libusb_get_active_config_descriptor
            ( libusb_get_device(device_handle), &cd);

  if (R) {
     // FIXME
    usb_print_error("get-active-config",R);
    exit(1);
  }

  id= (typeof(id)) cd->interface[0].altsetting + 0;

  ed= (typeof(ed)) id->endpoint;
  n_endpoints= id->bNumEndpoints;

  hci_event_ep= hci_command_ep= acl_in_ep= acl_out_ep= -1;

  for(i=0;i<n_endpoints;i++)
  {
    int addr;
    addr= ed[i].bEndpointAddress;
    switch(ed[i].bmAttributes&0x03)
    {
    case LIBUSB_TRANSFER_TYPE_CONTROL: hci_command_ep= addr; break;
    case LIBUSB_TRANSFER_TYPE_ISOCHRONOUS:
       // we are not supposed to have this
       break;
    case LIBUSB_TRANSFER_TYPE_BULK:
       if (addr&0x80) acl_in_ep= addr;
       else acl_out_ep= addr;
       break;
    case LIBUSB_TRANSFER_TYPE_INTERRUPT:
       hci_event_ep= addr;
       break;
    }
  }

  // even if the descriptor doesn't report this, it should be
  // present, I think.
  if (hci_command_ep==-1) hci_command_ep= 0; 

  printf("device endpoints:\n"
    "hci_command: %02x\n"
    "hci_event  : %02x\n"
    "acl_out    : %02x\n"
    "acl_in     : %02x\n",
   hci_command_ep, hci_event_ep, acl_out_ep, acl_in_ep);

  libusb_free_config_descriptor(cd);
}


#line 196 "/home/dodo/btstack/src/usb.u"

static void start_polling()
{
   intr_xfr= libusb_alloc_transfer(0);
   fill_and_submit_intr_xfr();
   bulk_xfr= libusb_alloc_transfer(0);
   fill_and_submit_bulk_xfr();
}
#line 212 "/home/dodo/btstack/src/usb.u"

static void fill_and_submit_intr_xfr()
{
   uint8_t *buffer;
   size_t size;
   int R;

   size= 300;
   buffer= malloc(size+EVENT_HEADER_SIZE);

   event_set_code(buffer, EVENT_hci_event);
   event_set_size(buffer, size+EVENT_HEADER_SIZE);

   libusb_fill_interrupt_transfer
      (intr_xfr, device_handle, hci_event_ep,
       buffer+EVENT_HEADER_SIZE, size, intr_cb, buffer, 6000);

   interpret_error_code
      ("submit-intr-xfr",
       libusb_submit_transfer(intr_xfr));
}

#line 245 "/home/dodo/btstack/src/usb.u"

static void fill_and_submit_bulk_xfr()
{
   uint8_t *buffer;
   size_t size;
   int R;

   size= 1030;
   buffer= malloc(size+EVENT_HEADER_SIZE);
   event_set_code(buffer, EVENT_acl_data);
   event_set_size(buffer, size+EVENT_HEADER_SIZE);
   libusb_fill_bulk_transfer
      (bulk_xfr, device_handle, acl_in_ep,
       buffer+EVENT_HEADER_SIZE, size, bulk_cb, buffer, 6000);

   interpret_error_code
      ("submit-bulk-xfr",
        libusb_submit_transfer(bulk_xfr));
}
#line 270 "/home/dodo/btstack/src/usb.u"

static void intr_cb(struct libusb_transfer *xfr)
{
  uint8_t *event;
  switch(xfr->status)
  {
    case LIBUSB_TRANSFER_COMPLETED: break;

    case LIBUSB_TRANSFER_ERROR:
    case LIBUSB_TRANSFER_TIMED_OUT:
    case LIBUSB_TRANSFER_CANCELLED: 
        //free(xfr->user_data);
        fill_and_submit_intr_xfr();
        return ;
    default:
    case LIBUSB_TRANSFER_STALL: 
    case LIBUSB_TRANSFER_OVERFLOW: 
        //free(xfr->user_data);
        //libusb_free_transfer(xfr);
        interpret_error_code("recv-intr", LIBUSB_ERROR_IO);
        return ;
    case LIBUSB_TRANSFER_NO_DEVICE: 
        //libusb_free_transfer(xfr);
        //free(xfr->user_data);
        interpret_error_code("recv-intr", LIBUSB_ERROR_NO_DEVICE);
        return ;
  }

  event= xfr->user_data;
  event_set_length(event,xfr->actual_length);

  check_for_hci_available(event);

  event_dispatch(event);
  fill_and_submit_intr_xfr(); 
}

#line 313 "/home/dodo/btstack/src/usb.u"

static void bulk_cb(struct libusb_transfer *xfr)
{
  uint8_t *event;
  // printf("bulk_cb called\n");
  switch(xfr->status)
  {
    case LIBUSB_TRANSFER_COMPLETED: break;
    case LIBUSB_TRANSFER_TIMED_OUT:
         // printf("bulk_read timed-out, trying again\n");
        fill_and_submit_bulk_xfr();
        return ;

    case LIBUSB_TRANSFER_ERROR:
    case LIBUSB_TRANSFER_CANCELLED: 
        //free(xfr->buffer);
        fill_and_submit_bulk_xfr();
        return ;
    default:
    case LIBUSB_TRANSFER_STALL: 
    case LIBUSB_TRANSFER_OVERFLOW: 
        //free(xfr->buffer);
        //libusb_free_transfer(xfr);
        interpret_error_code("recv-intr", LIBUSB_ERROR_IO);
        return ;
    case LIBUSB_TRANSFER_NO_DEVICE: 
        //free(xfr->buffer);
        //libusb_free_transfer(xfr);
        interpret_error_code("recv-intr", LIBUSB_ERROR_NO_DEVICE);
        return ;
  }
  event= xfr->user_data;
  event_set_length(event,xfr->actual_length);
  handle_acl_packet(event + EVENT_HEADER_SIZE);
  // event_dispatch(event);
  fill_and_submit_bulk_xfr(); 
}

#line 66 "/home/dodo/btstack/src/threads.u"

void init_threads()
{
   nthreads= 0; sthreads= 10;
   threads= malloc(sizeof(*threads)*sthreads);
   main_coth= coth_main();
}

#line 140 "/home/dodo/btstack/src/threads.u"

int wait_for_events_2(thread_t *T)
{
   void **event_buffer;
   int nevents, hevents, sevents;
   int i;
   event_t *E;

   if (T->event) { free(T->event); T->event= 0; }
   T->match= 0;

   for_EVENTS(E)
     if (event_matches_thread(E->event,T))
     {
       event_dequeue(E);
       return T->match;
     }

   T->state= 'W';
   coth_switch(T->self_ctx, main_coth);
   return T->match;
}

#line 83 "/home/dodo/btstack/src/hci.u"

static void control_cb(struct libusb_transfer* xfr)
{
   int *numberp;
   numberp= xfr->user_data;
   system_event(SYSTEM_control_transfer_done,"dd", *numberp, xfr->status);
}

#line 96 "/home/dodo/btstack/src/hci.u"

uint8_t *hci_command_packet_for_usb
  (int opcode, uint8_t *param, size_t plen)
{
   uint8_t *usb_buffer;
   int hci_packet_len;
   int usb_packet_len;
   int i;

   hci_packet_len= plen + 3;
   usb_packet_len= hci_packet_len + 8;
   
   usb_buffer= malloc(usb_packet_len);
   i= 0;
   // USB Setup Packet
   usb_buffer[i++]= 0x20;                                  //bmRequestType
   usb_buffer[i++]= 0x00;                                  //bRequest
   usb_buffer[i++]= 0x00; usb_buffer[i++]= 0x00;           //wValue
   usb_buffer[i++]= 0x00; usb_buffer[i++]= 0x00;           //wIndex
   usb_buffer[i++]= hci_packet_len & 0xff;
   usb_buffer[i++]= hci_packet_len >> 8;                   // wLength

   // HCI Command Header

   usb_buffer[i++]= opcode & 0xff;
   usb_buffer[i++]= opcode >> 8;
   usb_buffer[i++]= plen;
   if (plen)
      memcpy(usb_buffer+i, param, plen);

   return usb_buffer;
}

#line 136 "/home/dodo/btstack/src/hci.u"

void check_for_hci_available(uint8_t *event)
{
   static uint32_t emask[255];
   static int emask_ok=0;

   uint8_t *result[2], *dummy[2];
   int i,c,n;

   if (!emask_ok)
   {
#line 772 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0006<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x000c<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0f),
(0x04<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy( emask, _TPL, sizeof(_TPL));
} while(0);
switch( 1){
case 1:
break;
case 2:
break;
}
#line 156 "/home/dodo/btstack/src/hci.u"
     emask_ok= 1;
   }

   if (!event_match_2(emask, event,result))
     return ;

   n= result[0][0];
#if 0
   printf("GOT %d HCI_AVAIL\n",n);
#endif

   // now we simply set the resource

   resource_set(hci_available_resource, n);
}

#line 246 "/home/dodo/btstack/src/hci.u"

const char *hci_error_code(uint32_t X)
{
  switch(X)
  {
  case 0x0c: return "Command disallowed";
  case 0x01: return "Unknown HCI command";
  case 0x12: return "Invalid HCI command parameters";
  case 0x0b: return "ACL connection already exists";
  case 0x0d: return "Connection rejected due to limited resources";
  case 0x04: return "Page timeout";
  }
  return "Unknown HCI Error";
}

#line 13 "/home/dodo/btstack/src/inquiry.u"


void inquiry(thread_t *T)
{
   int opcode;
   uint8_t buffer[255];
   int N,i;
   uint8_t *bd_addr, *psrm, // page_scan_repetition_mode, whatever that is
           *class_of_device,*clock_offset, *rssi;

   resource_get(T, inquiry_lock);

   i= 0;
   buffer[i++]= 0x33;  // LAP for the inquiry access code
   buffer[i++]= 0x8B;  //     This LAP is called GAIC or something like that. 
   buffer[i++]= 0x9E;  //     It's like a broadcast address
   buffer[i++]= 0x04;  // do it for about 6 seconds
   buffer[i++]= 0x00;  // unlimited number of responses

   if (send_hci_command_expect_status(T, HCI_COMMAND_inquiry, buffer, 5))
     goto done;

#line 852 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0007<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x02),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x04<<24) | (0x0009<<8) | (0x01),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x000e<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x22),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x04<<24) | (0x0009<<8) | (0x01),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x01),
(0x01<<24) | (0x0008<<8) | ((0)>>0),
(0x02<<24) | (0x03), 
(0x03<<24) | (0x001a<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x01),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x04), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
} while(0);
again:
switch(wait_for_events_2(T)){
case 1:
    N= T->edata[0][0];
    bd_addr= T->edata[1];
    psrm= bd_addr + N*6;
    class_of_device= psrm + N*3;
    clock_offset= class_of_device + N*3;
    rssi= NULL;
    goto got_result;
break;
case 2:
   N= T->edata[0][0];
   bd_addr= T->edata[1];
   psrm= bd_addr + N*6;
   class_of_device= psrm + N*2;
   clock_offset= class_of_device + N*3;
   rssi= clock_offset+ N*2;
   goto got_result;
break;
case 3:
    goto done;
break;
case 4:
      fprintf(stderr,"Inquiry command failed with code: %02x\n",
                           T->edata[0][0]);
      goto done;
break;
}
#line 40 "/home/dodo/btstack/src/inquiry.u"

got_result:
   for(i=0;i<N;i++)
   {
     printf("found device\n");
       int yy;
       printf("  addr: ");
       for(yy=5;yy>=0;yy--) printf("%s%02x", yy!=5?":":"", bd_addr[yy]);
       printf("\n");
       // print_hex("  addr", bd_addr,6);
       print_hex("  psrm", psrm,1);
       print_hex("  class", class_of_device, 3);
       print_hex("  clock offset", clock_offset, 2);
       if (rssi) print_hex("  rssi", rssi, 1);

     device_t *D;
     D= get_device(bd_addr);
     D->is_live= 1;

     dp_device_psrm(bd_addr, psrm[0]);
     dp_device_class(bd_addr, class_of_device);

     D->clock_offset= clock_offset[0] | (clock_offset[1]<<8);
     if (rssi) {
       D->H_rssi= 1;
       D->rssi= rssi[0];
     } else D->H_rssi= 0;

     bd_addr+= 6;
     psrm+= 1;
     class_of_device+= 3;
     clock_offset+= 2;
     if (rssi) rssi+= 1;
   }

   goto again;

done:
   resource_set(inquiry_lock, 1);
   printf("Inquiry command ended.\n");
}

#line 48 "/home/dodo/btstack/src/l2cap.u"

void handle_acl_packet(uint8_t *acl_packet)
{
  uint16_t conn_id;
  uint8_t pb;
  uint16_t acl_length;
  connection_t *C;
  int i;
  conn_id= (acl_packet[0] | (acl_packet[1]<<8))& 0x0fff;

  acl_length= acl_packet[2] | (acl_packet[3]<<8);

  pb= (acl_packet[1] & 0x30) >> 4;

  // printf("PB is %d for acl packet\n", pb);
  if (pb!=1 && pb!=2) {
    printf("unhandled PB, I will assume that it is a start packet\n");
    pb= 2;
    return ; }

  C= 0;
  for(i=0;i<n_connections;i++)
     if (connections[i]->id==conn_id) { C= connections[i]; break; }

  if (!C) {
     printf("can't find connection %02x, ignoring packet.\n",
        conn_id);
     return ;
  }

again:
  if (C->state)  // continuation
  {
    if (pb!=1) {
       printf("connection is in continuation state, but the "
              "packet specifies a new frame, is it trying to "
              "drop the previous one?\n I think so. So let's "
              "cancel the packets we got so far.\n");
       cancel_packets(C);
       goto again;
    }
    C->total_received+= acl_length;
    if (C->total_received>C->total_expected)
    {
        printf("we received too much data for one l2cap frame.\n");
        printf("received %d bytes, was expecting %d bytes at most.\n",
                  C->total_received, C->total_expected);
        printf("ignoring this packet and going back to the initial state \n"
                " normally, this connection would be terminated.\n");
        cancel_packets(C);
        return ;
    }
    pvecapd(C->packets, acl_packet);
    if (C->total_received==C->total_expected)
     assemble_frame(C);
  } else {  // initial
     if (pb!=2) {
        printf("connection is in initial state, but the packet "
               "is a continuation packet. So I guess we missed "
               "the start of the frame. I will simply ignore "
                "this packet and be done with it.\n");
        return ;
     }
     C->total_received= acl_length;
     C->total_expected= l2cap_length(acl_packet) + 4;
     if (C->total_received>C->total_expected)
     {
        printf("we received too much data for one l2cap frame.\n");
        printf("received %d bytes, was expecting %d bytes at most.\n",
                  C->total_received, C->total_expected);
        printf("ignoring this packet now. normallly, this connection \n"
                "would be terminated.\n");
        return ;
     }
     pvecapd(C->packets, acl_packet);
     if (C->total_received==C->total_expected)
       assemble_frame(C);
     else C->state= 1;
  }
}

int l2cap_length(uint8_t *acl_packet)
{
  acl_packet+= 4; // skip the ACL header: connection handle and acl length
  return acl_packet[0] | (acl_packet[1]<<8);
}


#line 137 "/home/dodo/btstack/src/l2cap.u"

uint32_t get_le16(uint8_t *K)
{
  return K[0] | (K[1]<<8);
}

#line 147 "/home/dodo/btstack/src/l2cap.u"

connection_t* create_connection(uint8_t *addr,uint32_t coha)
{
  connection_t *C;
  C= malloc(sizeof(*C));
  memcpy(C->addr, addr, 6);
  pvecini(&C->packets, &C->s_packets, &C->n_packets);
  C->id= coha;
  C->state= 0;
  C->total_received= 0;
  C->total_expected= 0;
  pvecapd(connections,C);
  return C;
}

#line 167 "/home/dodo/btstack/src/l2cap.u"

void send_echo_request(thread_t *T, uint32_t coha)
{
   uint8_t buffer[255];
   int i;
   int L;
   int DL;
   static uint8_t D[]= { 0xde, 0xad, 0xbe, 0xef, 0xba, 0xad, 0xbe, 0xef };

   DL= sizeof(D);

   i= 2;

   buffer[i++]= 0x01;   // channel lower byte
   buffer[i++]= 0x00;  // channel upper byte

   buffer[i++]= 0x0a; // info request
   buffer[i++]= 0x05; // identifier
   buffer[i++]= 2;
   buffer[i++]= 0;

   buffer[i++]= 0x01; 
   buffer[i++]= 0x00; 


   L= i-4;

   buffer[0]= L & 0xff;
   buffer[1]= L >> 8;

   send_l2cap_frame(T, coha, buffer, L+4);
}


static void bulk_send_cb(struct libusb_transfer *xfr)
{
  int st;
  int K;
  st= xfr->status;
#if 0
  if (st==LIBUSB_TRANSFER_COMPLETED)
    printf("bulk outbound transfer OK\n");
  else printf("bulk outbound transfer not OK, status is %d\n",st);
#endif

  K= *(int*) xfr->user_data;

  system_event(SYSTEM_acl_transfer_done, "dd", K, st);
}

void cancel_packets(connection_t *C)
{
  C->n_packets= 0;
  C->total_received= 0;
  C->total_expected= 0;
  C->state= 0;
}
#line 408 "/home/dodo/btstack/src/l2cap.u"

void assemble_frame(connection_t *C)
{
  int i;
  uint16_t frame_size,event_size;
  int offset;
  uint8_t *frame;
  uint8_t *event;
  int event_length;

  frame_size= C->total_expected;
  event_size= frame_size+ 10;
  event_length= frame_size+4;

  event= malloc(event_size);
  frame= event + 10;

  i= 0;
  i+= put_le16(event+i, event_size); 
  i+= put_le16(event+i, event_length);
  i+= put_le16(event+i, EVENT_system); 
  i+= put_le16(event+i, SYSTEM_l2cap_frame);
  i+= put_le16(event+i, C->id);

  offset= 0;
  for(i=0;i<C->n_packets;i++)
  {
    uint8_t *p;
    uint16_t acl_len;
    p= C->packets[i];
    acl_len= get_le16(p+2);
    memcpy(frame+offset, p+4, acl_len);
    offset+= acl_len;
  }

  event_dispatch(event);
  
#if 0
  for(i=0;i<C->n_packets;i++)
     free(C->packets[i]);
#endif
  C->n_packets= 0;
}

int put_le16(uint8_t *D, uint32_t V)
{
  D[0]= V & 0xff;
  D[1]= V>>8;
  return 2;
}

#line 460 "/home/dodo/btstack/src/l2cap.u"

void l2cap_frame(uint8_t *buffer, int channel, const char *fmt, ...)
{
   int i;
   int iarg; uint8_t *parg;
   int offset;
   va_list ap;
   offset= 4;
   va_start(ap,fmt);
   for(i=0;fmt[i];i++)
     switch(fmt[i])
     {
     case 'b':
        iarg= va_arg(ap,int);
        buffer[offset++]= iarg;
        break;
     case 'w':
        iarg= va_arg(ap,int);
        buffer[offset++]= iarg;
        buffer[offset++]= iarg>>8;
        break;
     case 'd':
        iarg= va_arg(ap,int);
        buffer[offset++]= iarg;
        buffer[offset++]= iarg>>8;
        buffer[offset++]= iarg>>16;
        buffer[offset++]= iarg>>24;
        break;
     case 'p':
        iarg= va_arg(ap,int);
        parg= va_arg(ap,uint8_t*);
        memcpy(buffer+offset, parg, iarg);
        offset+= iarg;
        break;
     }
  va_end(ap);
  put_le16(buffer,offset-4);
  put_le16(buffer+2, channel);
}

#line 834 "/home/dodo/btstack/src/l2cap.u"

channel_t *find_channel_by_identifier
  (uint32_t identifier, channel_t **channels, int n_channels)
{
  int i;
  for(i=0;i<n_channels;i++)
    if (channels[i]->state!='K' && 
        channels[i]->expected_identifier==identifier)
      return channels[i];
  return 0;
}

channel_t *find_channel_by_local_cid
   (uint32_t local_cid, channel_t **channels, int n_channels)
{
  int i;
  for(i=0;i<n_channels;i++)
    if (channels[i]->local_cid==local_cid)
      return channels[i];
  return 0;
}

int check_command_identifier(char *op, channel_t *S, uint32_t local_cid)
{
  if (S->local_cid!=local_cid)
  {
    printf("Remote device responded to connect command with wrong "
           "source_cid. we sent %04x, received back %04x. returning "
           "with error without further action.\n", S->local_cid, 
                             local_cid);
    return 1;
  }
  return 0;
}

#line 1066 "/home/dodo/btstack/src/l2cap.u"

channel_t* remove_channel(channel_t** channels, int n_channels, channel_t *S)
{
  int i;
  for(i=0;i<n_channels;i++)
    if (channels[i]==S)
    {
      pvecdel(channels,i);
      break;
    }
  free(S);
  return 0;
}

#line 156 "/home/dodo/btstack/src/poll.u"

void handle_usb_fds() {
  struct timeval tv;
  tv.tv_sec= 0;
  tv.tv_usec= 0;
  libusb_handle_events_timeout_completed(0,&tv, 0);
}

#line 198 "/home/dodo/btstack/src/poll.u"

static void add_libusb_fd(int fd, short events, void *arg)
{
  poll_fds[n_poll_fds]= poll_fds[n_libusb_fds];
  n_poll_fds++;
  poll_fds[n_libusb_fds].fd= fd;
  poll_fds[n_libusb_fds].events= events;
  poll_fds[n_libusb_fds].revents= 0;
  n_libusb_fds++;
}


static void remove_libusb_fd(int fd, void *arg)
{
  int i;
  for(i=0;i<n_libusb_fds;i++)
   if (poll_fds[i].fd==fd)
   {
     poll_fds[i]= poll_fds[n_libusb_fds-1];
     poll_fds[n_libusb_fds-1]= poll_fds[n_poll_fds-1];
     n_poll_fds--;
     n_libusb_fds--;
     break;
   }
}

#line 229 "/home/dodo/btstack/src/poll.u"

void poll_init()
{
  const struct libusb_pollfd **LF;
  int i;
  libusb_set_pollfd_notifiers(NULL,
       add_libusb_fd,
       remove_libusb_fd,
       NULL);

  LF= libusb_get_pollfds(NULL);
  for(i=0;LF[i];i++)
  {
    poll_fds[n_libusb_fds].fd= LF[i]->fd;
    poll_fds[n_libusb_fds].events= LF[i]->events;
    poll_fds[n_libusb_fds].revents= 0;
    n_libusb_fds++;
    n_poll_fds++;
  }
}

#line 6 "/home/dodo/btstack/src/agent-control.u"

void client_control_thread
  (thread_t *T, socket_t *socket, uint64_t bclient_id)
{
  int client_id;
  uint16_t local_cid, remote_cid;
  uint16_t coha;
  uint8_t addr[6]; uint16_t psm;
  int R;
  areader_t *rd;
  awriter_t *wr;

  rd= aread_init(socket, 4);
  wr= awrite_init(socket);

#line 171 "/home/dodo/btstack/src/agent-control.u"

  uint8_t *l_buffer; 
  uint8_t *r_buffer; uint16_t r_len; uint16_t r_total;
  uint8_t r_hdr[2];  uint8_t r_hdr_len;

#line 263 "/home/dodo/btstack/src/agent-control.u"

   uint8_t *w_buffer, *w_event; uint16_t w_total;

#line 177 "/home/dodo/btstack/src/agent-control.u"

  l_buffer= r_buffer= 0; r_hdr_len= r_len= r_total= 0;


#line 23 "/home/dodo/btstack/src/agent-control.u"

  client_id= bclient_id;


  if (get_connect_params(T, rd, addr, &psm))
    goto quit_immediate;

  if (psm==0 && get_le16(addr)==0 && get_le16(addr+2)==0
      && get_le16(addr+4)==0)
  {
    command_loop(T, rd, wr);
    goto quit_immediate;
  }

  if (control_connect(T, addr, psm, &coha, &local_cid, &remote_cid))
    goto quit_immediate;

  // This sends a single byte over the socket so that
  // the client can wait for the completion of the connection.
  send_connect_ok(wr);

  printf("connected to l2cap channel\n"
     "   local_cid= %04x\n"
     "   remote_cid= %04x\n"
     "   coha=       %04x\n", local_cid, remote_cid, coha);

main_loop:

  if (wr->first)
    add_poll_fd(socket->fd, 'R'+'W');
  else
    add_poll_fd(socket->fd, 'R');

#line 1393 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x09),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0022<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x18),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x02<<24) | (0x03), 
(0x03<<24) | (0x002d<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x04<<24) | (0x000e<<8) | (0x00),
(0x02<<24) | (0x04), 
(0x03<<24) | (0x0037<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x08),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x05), 
(0x03<<24) | (0x0041<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0a),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x06), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+6)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+7)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+8)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+15)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+16)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+17)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+18)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+25)= (addr)[0];
*(uint8_t*) (T->mask+26)= (addr)[1];
*(uint8_t*) (T->mask+27)= (addr)[2];
*(uint8_t*) (T->mask+28)= (addr)[3];
*(uint8_t*) (T->mask+29)= (addr)[4];
*(uint8_t*) (T->mask+30)= (addr)[5];
*(uint8_t*) (T->mask+31)= ((local_cid)>>0);
*(uint8_t*) (T->mask+32)= ((local_cid)>>8);
*(uint8_t*) (T->mask+39)= ((coha)>>0);
*(uint8_t*) (T->mask+40)= ((coha)>>8);
*(uint8_t*) (T->mask+41)= ((local_cid)>>0);
*(uint8_t*) (T->mask+42)= ((local_cid)>>8);
*(uint8_t*) (T->mask+50)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+51)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+52)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+53)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+60)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+61)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+62)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+63)= ((socket->fd)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
  if (r_hdr_len<2)
  {
    R= recv(socket->fd, r_hdr+r_hdr_len, 2-r_hdr_len, MSG_DONTWAIT );
    if (R<=0) goto recv_error;
    r_hdr_len+= R;
    if (r_hdr_len!=2) goto main_loop;
    r_total= get_le16(r_hdr);
    if (r_total==0)
    {
      l_buffer= r_buffer= 0; r_hdr_len= r_len= r_total= 0;
      goto main_loop;
    }
    r_len= 0;
    l_buffer= malloc( 4 + r_total );
    r_buffer= l_buffer+4;
    put_le16(l_buffer, r_total);
    put_le16(l_buffer+2, remote_cid);
  }
  else
  {
    R= recv(socket->fd, r_buffer+r_len,
                        r_total-r_len, MSG_DONTWAIT);
    if (R<=0) goto recv_error;
    r_len+= R;
    if (r_len!=r_total) goto main_loop;

    R= send_l2cap_frame(T, coha, l_buffer, r_total+4);
    // FIXME: we should check the target MTU first.
    // for that, the l2cap_connected message should
    // include the MTU.

    free(l_buffer);
    l_buffer= r_buffer= 0; r_hdr_len= r_len= r_total= 0;

    if (R) goto start_disconnect;
    else   goto main_loop;
  }
break;
case 2:
  goto start_disconnect;
break;
case 3:
  goto disconnected;
break;
case 4:
w_total= T->event[10] | (T->event[11]<<8);
        w_event = T->event;
        w_buffer= T->edata[0];
        T->event= 0;
#if 0
        printf("GOT data from l2cap, length= %d\n", w_total);
#endif
        awrite_put(wr, w_buffer, w_total, w_event);
break;
case 5:
    if (awrite_go(wr)) {
      printf("send error: %s\n", wr->errstr);
      goto start_disconnect;
    }
break;
case 6:
    goto start_disconnect;
break;
}
#line 60 "/home/dodo/btstack/src/agent-control.u"
  goto main_loop;
#line 230 "/home/dodo/btstack/src/agent-control.u"

recv_error:
  if (errno==EINTR || errno==EAGAIN || errno==EWOULDBLOCK)
     goto main_loop;
  fprintf(stderr,"recv() failed with %d (%s). quitting agent.\n",
                      errno, strerror(errno));            
  goto start_disconnect;

#line 306 "/home/dodo/btstack/src/agent-control.u"

start_disconnect:
  system_event(SYSTEM_disconnect_l2cap, "pww", 6, addr, local_cid,remote_cid);

#line 1574 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000e<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x18),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= (addr)[0];
*(uint8_t*) (T->mask+6)= (addr)[1];
*(uint8_t*) (T->mask+7)= (addr)[2];
*(uint8_t*) (T->mask+8)= (addr)[3];
*(uint8_t*) (T->mask+9)= (addr)[4];
*(uint8_t*) (T->mask+10)= (addr)[5];
*(uint8_t*) (T->mask+11)= ((local_cid)>>0);
*(uint8_t*) (T->mask+12)= ((local_cid)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
      goto disconnected;
break;
}
#line 319 "/home/dodo/btstack/src/agent-control.u"

#line 325 "/home/dodo/btstack/src/agent-control.u"
disconnected:
   remove_poll_fd(socket->fd);
   remove_socket_events(socket->fd);
   socket_destroy(socket);
   goto wait_stale_data;

#line 341 "/home/dodo/btstack/src/agent-control.u"

wait_stale_data:
#line 1619 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0012<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x1e),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((coha)>>0);
*(uint8_t*) (T->mask+6)= ((coha)>>8);
*(uint8_t*) (T->mask+7)= ((local_cid)>>0);
*(uint8_t*) (T->mask+8)= ((local_cid)>>8);
*(uint8_t*) (T->mask+15)= ((local_cid)>>0);
*(uint8_t*) (T->mask+16)= ((local_cid)>>8);
} while(0);
wait_stale:
switch(wait_for_events_2(T)){
case 1:
       // ignoring it like there is no tomorrow.
       printf("got one stale data packet for %04x:%04x\n", coha, local_cid);
break;
case 2:
       printf("channel %04x is getting out of purgatory\n",local_cid);
       thread_exit(T); // FIXME: is there anything I should deallocate?
break;
}
#line 360 "/home/dodo/btstack/src/agent-control.u"
goto wait_stale;

#line 62 "/home/dodo/btstack/src/agent-control.u"
quit_immediate:
  remove_poll_fd(socket->fd);
  remove_socket_events(socket->fd);
  socket_destroy(socket);
  awrite_free(wr);
  aread_free(rd);
  thread_exit(T);
}

#line 76 "/home/dodo/btstack/src/agent-control.u"

int get_connect_params(thread_t *T, areader_t *ard,
                       uint8_t *addr, uint16_t *psm)
{
again:
   add_poll_fd(ard->socket->fd, 'R');
#line 1680 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x09),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((ard->socket->fd)>>0);
*(uint8_t*) (T->mask+6)= ((ard->socket->fd)>>8);
*(uint8_t*) (T->mask+7)= ((ard->socket->fd)>>16);
*(uint8_t*) (T->mask+8)= ((ard->socket->fd)>>24);
*(uint8_t*) (T->mask+15)= ((ard->socket->fd)>>0);
*(uint8_t*) (T->mask+16)= ((ard->socket->fd)>>8);
*(uint8_t*) (T->mask+17)= ((ard->socket->fd)>>16);
*(uint8_t*) (T->mask+18)= ((ard->socket->fd)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
    if (aread_go(ard))
    {
      if (ard->complete)
      {
        if (ard->size!=8) return 1; // invalid size
        memcpy(addr, ard->buffer+ard->extra_hdr, 6);
        *psm= get_le16(ard->buffer+ard->extra_hdr+6);
        aread_start(ard);
        return 0;
      }
      printf("Error while getting connection parameters: %s\n", ard->errstr);
      return 1; // we have an error
    }
    goto again;
break;
case 2:
   return 1;
break;
}
#line 109 "/home/dodo/btstack/src/agent-control.u"
    goto again;
}

#line 116 "/home/dodo/btstack/src/agent-control.u"

int control_connect(thread_t *T, uint8_t *addr, uint16_t psm,
                    uint16_t *Rcoha, uint16_t *Rlocal_cid,
                                     uint16_t *Rremote_cid)
{
  device_t *D;
  D= get_device(addr);
  if (!D->is_live)
    inquiry(T);
#if 0
  if (!D->is_live)
   { printf("can't find remote device. exiting.\n"); return 1; }
#endif

   if (connect_device(T,D->addr,Rcoha))
    { printf("can't connect to device. exiting.\n"); return 1; }

  printf("Connect OK. coha= %04x\n",*Rcoha);

  system_event(SYSTEM_connect_l2cap, "pw", 6, addr, psm);

#line 1761 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000e<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x16),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x0010<<8) | (0x00),
(0x01<<24) | (0x0011<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x001c<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x17),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= (addr)[0];
*(uint8_t*) (T->mask+6)= (addr)[1];
*(uint8_t*) (T->mask+7)= (addr)[2];
*(uint8_t*) (T->mask+8)= (addr)[3];
*(uint8_t*) (T->mask+9)= (addr)[4];
*(uint8_t*) (T->mask+10)= (addr)[5];
*(uint8_t*) (T->mask+11)= ((psm)>>0);
*(uint8_t*) (T->mask+12)= ((psm)>>8);
*(uint8_t*) (T->mask+19)= (addr)[0];
*(uint8_t*) (T->mask+20)= (addr)[1];
*(uint8_t*) (T->mask+21)= (addr)[2];
*(uint8_t*) (T->mask+22)= (addr)[3];
*(uint8_t*) (T->mask+23)= (addr)[4];
*(uint8_t*) (T->mask+24)= (addr)[5];
*(uint8_t*) (T->mask+25)= ((psm)>>0);
*(uint8_t*) (T->mask+26)= ((psm)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
*Rcoha= T->event[14] | (T->event[15]<<8);
*Rlocal_cid= T->event[18] | (T->event[19]<<8);
*Rremote_cid= T->event[20] | (T->event[21]<<8);
       return 0;
break;
case 2:
       return 1;
break;
}
#line 155 "/home/dodo/btstack/src/agent-control.u"
    return 1;
}

#line 377 "/home/dodo/btstack/src/agent-control.u"

static void send_connect_ok(awriter_t *wr)
{
  uint8_t *OK;
  OK= malloc(3);
  OK[2]= 0;
  awrite_put(wr, OK+2,1, OK);
}
#line 398 "/home/dodo/btstack/src/agent-control.u"

void command_loop(thread_t *T, areader_t *rd, awriter_t *wr)
{
  socket_t *socket;
  uint8_t *B;
  uint16_t command;
  socket= rd->socket;

restart:
  aread_start(rd);
again:
  if (wr->first)
    add_poll_fd(socket->fd, 'R'+'W');
  else
    add_poll_fd(socket->fd, 'R');

#line 1852 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x09),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x001e<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0a),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x03), 
(0x03<<24) | (0x0028<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x08),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x04), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+6)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+7)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+8)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+15)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+16)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+17)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+18)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+25)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+26)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+27)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+28)= ((socket->fd)>>24);
*(uint8_t*) (T->mask+35)= ((socket->fd)>>0);
*(uint8_t*) (T->mask+36)= ((socket->fd)>>8);
*(uint8_t*) (T->mask+37)= ((socket->fd)>>16);
*(uint8_t*) (T->mask+38)= ((socket->fd)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
    if (aread_go(rd))
    {
      if (rd->error)
      {
        printf("read error: %s\n", rd->errstr);
        return ;
      }
      goto interp;
    }
break;
case 2:
    return ;
break;
case 3:
    return ;
break;
case 4:
    if (awrite_go(wr))
      return ;
break;
}
#line 446 "/home/dodo/btstack/src/agent-control.u"
  goto again;

interp:
  B= rd->buffer+4; // we had 4 bytes of space for the l2cap buffer

  B+= bscan(B, "w", &command);
  switch(command)
  {
  case COM_DEVICES:
     send_device_list(wr);
     break;
  case COM_INQUIRE:
     inquiry(T);
     send_device_list(wr);
     break;
  case COM_NAME:
     send_device_name(T, B, wr);
     break;
  default:
     return ;
  }
  goto restart;
}

#line 474 "/home/dodo/btstack/src/agent-control.u"

void send_device_list(awriter_t *wr)
{
  uint16_t N;
  device_t *D;
  uint8_t *buffer,*B;
  int L;
  N= 0;
  for(D=devices.next;D!=&devices;D=D->next)
    if (D->is_live) N++;
  
  L= 2+N*6;
  buffer= malloc(2+L);

  B= buffer+2;
  B+= bpack(B, 2, "w", N,NULL);
  for(D=devices.next;D!=&devices;D=D->next)
    if (D->is_live)
      B+= bpack(B, 6, "p", 6, D->addr, NULL);
  awrite_put(wr, buffer+2, L, buffer);
}

void send_device_name(thread_t *T, uint8_t *addr, awriter_t *wr)
{
  device_t *D;
  uint8_t buffer[255];
  int i;
  int L;
  uint8_t *name;
  uint8_t *obuf;
  uint8_t psrm;
  uint16_t clk_offset;


  D= find_device_by_addr(addr);
  if (!D) goto fail;

  if (dg_device_psrm(addr, &psrm))
    goto fail;

  if (D->is_live)
    clk_offset= D->clock_offset | (1<<15);
  else
    clk_offset= D->clock_offset & ~(1<<15);
 
  i= bpack(buffer, 255, "p", 6, addr,
                        "bb", psrm,0,
                        "w", clk_offset,
                   NULL);

  if (send_hci_command_expect_status(T,
            HCI_COMMAND_read_remote_name_request, buffer, i))
  {
     printf("get_name(%s): can't send HCI command, cancelling.\n",
                         bd_addr_to_str(D->addr));
     goto fail; 
  }

again:
#line 2022 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000b<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x3d),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0018<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | ((0)>>0),
(0x04<<24) | (0x000f<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0024<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x03), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+4)= (addr)[0];
*(uint8_t*) (T->mask+5)= (addr)[1];
*(uint8_t*) (T->mask+6)= (addr)[2];
*(uint8_t*) (T->mask+7)= (addr)[3];
*(uint8_t*) (T->mask+8)= (addr)[4];
*(uint8_t*) (T->mask+9)= (addr)[5];
*(uint8_t*) (T->mask+15)= (D->addr)[0];
*(uint8_t*) (T->mask+16)= (D->addr)[1];
*(uint8_t*) (T->mask+17)= (D->addr)[2];
*(uint8_t*) (T->mask+18)= (D->addr)[3];
*(uint8_t*) (T->mask+19)= (D->addr)[4];
*(uint8_t*) (T->mask+20)= (D->addr)[5];
*(uint8_t*) (T->mask+28)= (D->addr)[0];
*(uint8_t*) (T->mask+29)= (D->addr)[1];
*(uint8_t*) (T->mask+30)= (D->addr)[2];
*(uint8_t*) (T->mask+31)= (D->addr)[3];
*(uint8_t*) (T->mask+32)= (D->addr)[4];
*(uint8_t*) (T->mask+33)= (D->addr)[5];
} while(0);
switch(wait_for_events_2(T)){
case 1:
     printf("got supported features for %s, ignoring.\n",
            bd_addr_to_str(addr));
break;
case 2:
     name= T->edata[0];
     L= strnlen(name,248);
     obuf= malloc(2+L+1);
     memcpy(obuf+2, name, L);
     obuf[2+L]= 0;
     awrite_put(wr, obuf+2, L+1, obuf);
     return ;
break;
case 3:
     // here, we match anything with status!=0 
     printf("remote name request failed with code= %02x\n", T->edata[0][0]);
     goto fail;
break;
}
#line 563 "/home/dodo/btstack/src/agent-control.u"
  goto again;

fail:
  mbpack(&obuf, "wb", 0, 0, NULL);
  awrite_put(wr, obuf+2, 1, obuf);
}

device_t *find_device_by_addr(uint8_t *addr)
{
  device_t *D;
  for(D=devices.next;D!=&devices;D=D->next)
    if (!memcmp(D->addr,addr, 6))
     return D;
  return NULL;
}

char *bd_addr_to_str(uint8_t *addr)
{
  static char buf[200];
  int i,b;
  b= 0;
  for(i=5;i>=0;i--)
    {
       if (i!=5) buf[b++]= ':';
       sprintf(buf+b, "%02x",addr[i]);
       b+= 2;
    }
  buf[b]= 0;
  return buf;
}

#line 9 "/home/dodo/btstack/src/agent-server.u"

void server_thread(thread_t *T)
{
   socket_t *server_socket;
   socket_t *client_socket;
   static int last_client_id= 1;

   server_socket= socket_server_local(60712);
   if (server_socket->state==SOCKET_ERROR)
     {
        fprintf(stderr,"can't create server socket: %s\n", 
                        server_socket->errstr);
        free(server_socket);
        thread_exit(T);
     }

again:
   add_poll_fd(server_socket->fd, 'R');
#line 2153 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x07),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x09),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((server_socket->fd)>>0);
*(uint8_t*) (T->mask+6)= ((server_socket->fd)>>8);
*(uint8_t*) (T->mask+7)= ((server_socket->fd)>>16);
*(uint8_t*) (T->mask+8)= ((server_socket->fd)>>24);
*(uint8_t*) (T->mask+15)= ((server_socket->fd)>>0);
*(uint8_t*) (T->mask+16)= ((server_socket->fd)>>8);
*(uint8_t*) (T->mask+17)= ((server_socket->fd)>>16);
*(uint8_t*) (T->mask+18)= ((server_socket->fd)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
    client_socket= socket_accept(server_socket);
    if (client_socket->state==SOCKET_ERROR)
    {
      fprintf(stderr,"error during new connection: %s\n", 
                      client_socket->errstr);
      free(client_socket);
      goto again;
    }
    create_client_thread(client_control_thread,client_socket, last_client_id);

    printf("new connection established. client id= %d\n",last_client_id);

    last_client_id++;
    break;
break;
case 2:
    fprintf(stderr,"there was an exception associated with the "
                   "server socket. aborting the server thread.\n");
    socket_destroy(server_socket);
    thread_exit(T);
break;
}
#line 31 "/home/dodo/btstack/src/agent-server.u"
  goto again;
}

#line 60 "/home/dodo/btstack/src/agent-server.u"

void create_client_thread(void *func, socket_t *socket, int client_id)
{
   thread_t *child_thread;
   child_thread= create_thread(func);
   coth_arg(child_thread->self_ctx, 2, socket);
   coth_arg(child_thread->self_ctx, 3, (void*) (int64_t) client_id);
}
#line 77 "/home/dodo/btstack/src/pincode.u"

static void send_link_key(thread_t *T, uint8_t *addr)
{
  uint8_t status;
  uint8_t link_key[16];
  uint8_t buffer[255];
  int L;
  int opcode;
  if (dg_device_link_key(addr, link_key))
  {
    opcode= OGF(0x01) | OCF(0x0C); // we don't have it
    if (send_hci_command(T, opcode, addr,6))
      return ;
  }
  else
  {
    opcode= OGF(0x01) | OCF(0x0B); // we do have it
    L= bpack(buffer, 255,"pp", 6,addr, 16, link_key, NULL);
    if (send_hci_command(T,opcode, buffer, L))
      return ;
  }
#line 2246 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000d<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x0b),
(0x01<<24) | (0x000a<<8) | (0x04),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x01<<24) | (0x0010<<8) | (0x00),
(0x01<<24) | (0x0011<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x001a<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x0c),
(0x01<<24) | (0x000a<<8) | (0x04),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x01<<24) | (0x0010<<8) | (0x00),
(0x01<<24) | (0x0011<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+6)= (addr)[0];
*(uint8_t*) (T->mask+7)= (addr)[1];
*(uint8_t*) (T->mask+8)= (addr)[2];
*(uint8_t*) (T->mask+9)= (addr)[3];
*(uint8_t*) (T->mask+10)= (addr)[4];
*(uint8_t*) (T->mask+11)= (addr)[5];
*(uint8_t*) (T->mask+19)= (addr)[0];
*(uint8_t*) (T->mask+20)= (addr)[1];
*(uint8_t*) (T->mask+21)= (addr)[2];
*(uint8_t*) (T->mask+22)= (addr)[3];
*(uint8_t*) (T->mask+23)= (addr)[4];
*(uint8_t*) (T->mask+24)= (addr)[5];
} while(0);
switch(wait_for_events_2(T)){
case 1:
status= T->event[11];
    printf("Tried to send link key. status= %02x\n", status);
break;
case 2:
status= T->event[11];
    printf("Didn't send a link key. status= %02x\n", status);
break;
}
#line 113 "/home/dodo/btstack/src/pincode.u"
}

#line 31 "/home/dodo/btstack/src/controller.u"

void read_local_supported_features(thread_t *T)
{
   uint8_t buffer[255];
   int i;
   uint8_t *data;
   uint64_t V;

   controller.H_local_supported_features= 0;

   if (send_hci_command_expect_complete(T, OCF(0x03) | OGF(0x04), buffer,0,1))
      goto done;
					   // skip the status byte
   data= hci_command_complete_event_data(T->event) + 1;

   print_hex("supported features", data, 8);
   controller.H_local_supported_features= 1;

   V= 0;
   for(i=0;i<8;i++)
     {
       V= V<<8;
       V |= data[i];
     }
   controller.local_supported_features= V;
done:
   return ;
}


void read_buffer_size(thread_t *T)
{
   uint8_t buffer[255];
   int i;

   controller.H_buffer_sizes= 0;

   if (send_hci_command(T, OGF(0x04) | OCF(0x05), buffer, 0))
     goto fail;

#line 2344 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000c<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x05),
(0x01<<24) | (0x000a<<8) | (0x10),
(0x01<<24) | (0x000b<<8) | ((0)>>0),
(0x04<<24) | (0x000c<<8) | (0x00),
(0x04<<24) | (0x000e<<8) | (0x01),
(0x04<<24) | (0x000f<<8) | (0x02),
(0x04<<24) | (0x0011<<8) | (0x03),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0014<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x05),
(0x01<<24) | (0x000a<<8) | (0x10),
(0x04<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
} while(0);
switch(wait_for_events_2(T)){
case 1:
     controller.H_buffer_sizes= 1;
     controller.max_acl_packet_len= T->edata[0][0] | (T->edata[0][1]<<8);
     controller.max_sco_packet_len= T->edata[1][0];
     controller.num_acl_packets= T->edata[2][0] | (T->edata[2][1]<<8);
     controller.num_sco_packets= T->edata[3][0] | (T->edata[3][1]<<8);

     printf("Buffer Sizes\n");
     printf("  ACL_packet_length= %d\n"
            "  SCO_packet_length= %d\n"
            "  ACL_num_packets= %d\n" 
            "  SCO_num_packets= %d\n",
                controller.max_acl_packet_len,
                controller.max_sco_packet_len,
                controller.num_acl_packets,
                controller.num_sco_packets);
     break;
break;
case 2:
    printf("read buffer size command failed with code %02x (%s)\n",
          T->edata[0][0], hci_error_code(T->edata[0][0]));
    goto fail;
    break;   
break;
}
#line 107 "/home/dodo/btstack/src/controller.u"

   return ;
fail:
   controller.H_buffer_sizes= 1;
   controller.max_acl_packet_len= 17; // DM1 packet
   controller.max_sco_packet_len= 10; // HV1 packet
   controller.num_acl_packets= 1;
   controller.num_sco_packets= 1;
}


#line 22 "/home/dodo/btstack/src/usb.u"

int usb_init()
{
   int r;
   const struct libusb_version* ver;

   r= libusb_init(NULL);
   if (r) {
     interpret_error_code("init-lib", r);
     return 1;
   }
   ver= libusb_get_version();
   printf("Initialized libusb-%d.%d.%d.%d%s.\n",
           ver->major, ver->minor, ver->micro, ver->nano, ver->rc);
   if (usb_open())
     return 1;
   figure_out_endpoints();
   start_polling();
   return 0;
}

void usb_print_error(char *op, int code)
{
   uprintf("%s: libusb error (%d) %s\n", op, code,
                     libusb_error_name(code)); 
}

#line 50 "/home/dodo/btstack/src/usb.u"

int usb_open()
{
  device_handle= libusb_open_device_with_vid_pid(0, vendor_id(), product_id());
  if (!device_handle)
  {
    uprintf("Can't open device %04x:%04x\n", vendor_id(), product_id());
    exit(1);
  } else {
    libusb_detach_kernel_driver(device_handle,0);
//
// Here, we activate the interface 0 without looking at the device
// descriptor and the interface descriptors because the Bluetooth Spec
// says that interface 0 is for the time when there is no audio channel
// active.
//
// We didn't look at the active configuration either, since my device
// has only one. Otherwise, I'd have to look at the configurations
// and then activate the one with bluetooth stuff in it.
//
    libusb_claim_interface(device_handle, 0);
    uprintf("Opened device.\n");
    return 0;
  }
}

#line 31 "/home/dodo/btstack/src/threads.u"

thread_t *create_thread(void (*func)(thread_t *))
{
   thread_t *T;
   T= malloc(sizeof(*T));

   T->self_ctx= coth_new((void*)func, 100*4096);
   coth_arg(T->self_ctx, 1, T);

   T->state= 'R';
   T->event= 0;
   T->match= 0;
   if (nthreads==sthreads)
   {
     int i;
     thread_t **tt;
     sthreads *= 2;
     tt= malloc(sizeof(thread_t*)*sthreads);
     for(i=0;i<nthreads;i++)
       tt[i]= threads[i];
     free(threads);
     threads= tt; 
   }
   threads[nthreads++]= T;
   return T;
}

#line 85 "/home/dodo/btstack/src/threads.u"


void event_dispatch(uint8_t *event)
{
  int i;

  if (event_print_flag) {
     int sz;
     sz= event_get_length(event);
     print_hex("new event", event, sz+6);
     print_event(event);
  }

  for(i=0;i<nthreads;i++)
    if (threads[i]->state=='W')
    {
       if (event_matches_thread(event, threads[i]))
       {
         threads[i]->state= 'R';
         return ;
       }
    }
  event_queue(event);
}


int event_matches_thread(uint8_t *event, thread_t *T)
{
  int M;
  M= event_match_2(T->mask, event, T->edata);
  if (!M) return 0;
  T->match= M;
  T->event= event;
  return M;
}

#line 127 "/home/dodo/btstack/src/threads.u"

void thread_exit(thread_t *T)
{
   T->state= 'D';
   coth_switch(T->self_ctx,main_coth);
}

#line 167 "/home/dodo/btstack/src/threads.u"

void thread_suspend(thread_t *T, int how)
{
  T->state= how;
  coth_switch(T->self_ctx, main_coth);
}

void thread_wakeup(thread_t *T)
{
  T->state= 'R';
}

#line 9 "/home/dodo/btstack/src/hci.u"

int send_hci_command
  (thread_t *T,int opcode, uint8_t *param, size_t plen)
{
   uint8_t *buffer;
   struct libusb_transfer* xfr;
   static int last_hci_number=1;
   int return_value, number;
   int R;
   int n_tries;

   n_tries= 0;
   return_value= 1;


   buffer= hci_command_packet_for_usb(opcode, param, plen);
   xfr= libusb_alloc_transfer(0);

try_again:
   number= last_hci_number++;
   libusb_fill_control_transfer(xfr, device_handle, buffer,
                                control_cb, &number, 1000);

   resource_get(T, hci_available_resource);

   R= libusb_submit_transfer(xfr);
   if (R) {
     interpret_error_code("submit-hci-xfr",R);
     goto done;
   }
   
#line 2581 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000e<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x02),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | ((LIBUSB_TRANSFER_COMPLETED)>>0),
(0x01<<24) | (0x000d<<8) | ((LIBUSB_TRANSFER_COMPLETED)>>1),
(0x01<<24) | (0x000e<<8) | ((LIBUSB_TRANSFER_COMPLETED)>>2),
(0x01<<24) | (0x000f<<8) | ((LIBUSB_TRANSFER_COMPLETED)>>3),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x001c<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x02),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | ((LIBUSB_TRANSFER_TIMED_OUT)>>0),
(0x01<<24) | (0x000d<<8) | ((LIBUSB_TRANSFER_TIMED_OUT)>>1),
(0x01<<24) | (0x000e<<8) | ((LIBUSB_TRANSFER_TIMED_OUT)>>2),
(0x01<<24) | (0x000f<<8) | ((LIBUSB_TRANSFER_TIMED_OUT)>>3),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0026<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x02),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x03), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((number)>>0);
*(uint8_t*) (T->mask+6)= ((number)>>8);
*(uint8_t*) (T->mask+7)= ((number)>>16);
*(uint8_t*) (T->mask+8)= ((number)>>24);
*(uint8_t*) (T->mask+19)= ((number)>>0);
*(uint8_t*) (T->mask+20)= ((number)>>8);
*(uint8_t*) (T->mask+21)= ((number)>>16);
*(uint8_t*) (T->mask+22)= ((number)>>24);
*(uint8_t*) (T->mask+33)= ((number)>>0);
*(uint8_t*) (T->mask+34)= ((number)>>8);
*(uint8_t*) (T->mask+35)= ((number)>>16);
*(uint8_t*) (T->mask+36)= ((number)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
        // printf(" WAIT OK\n");
        return_value= 0;
        break;
break;
case 2:
        // printf(" WAIT TIME OUT\n");
        n_tries++;
        if (n_tries>=3) // FIXME: make it configurable
           goto done;
        goto try_again;
        break;
break;
case 3:
       // all other completion status values
        // printf(" WAIT OTHER\n");
        break;
break;
}
#line 69 "/home/dodo/btstack/src/hci.u"

done:
   free(buffer);
   // libusb_free_transfer(xfr);
   return return_value;
}

#line 178 "/home/dodo/btstack/src/hci.u"

int send_hci_command_expect_status
  (thread_t *T,uint32_t opcode, uint8_t *param, size_t plen)
{
   if (send_hci_command(T, opcode, param, plen))
     return 1;

#line 2673 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0008<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0f),
(0x01<<24) | (0x0008<<8) | ((0)>>0),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0010<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0f),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((opcode)>>0);
*(uint8_t*) (T->mask+6)= ((opcode)>>8);
*(uint8_t*) (T->mask+12)= ((opcode)>>0);
*(uint8_t*) (T->mask+13)= ((opcode)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
    break;
break;
case 2:
      printf("HCI command %02x failed with code %02x (%s)\n",
           opcode, T->edata[0][0], hci_error_code(T->edata[0][0]));
      return 1;
break;
}
#line 203 "/home/dodo/btstack/src/hci.u"
   return 0;
}

int send_hci_command_expect_complete
  (thread_t *T,uint32_t opcode, uint8_t *param, size_t plen,int has_status)
{
   if (send_hci_command(T, opcode, param, plen))
     return 1;

#if 0
  printf("waiting for the complete event\n");
#endif
  if (has_status)
  {
#line 2724 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0008<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x04<<24) | (0x000b<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+4)= ((opcode)>>0);
*(uint8_t*) (T->mask+5)= ((opcode)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
      if (T->edata[0][0]!=0)
      {
        printf("HCI command %02x failed with code %02x (%s)\n",
             opcode, T->edata[0][0], hci_error_code(T->edata[0][0]));
        return 1;
      }
      break;
break;
}
#line 232 "/home/dodo/btstack/src/hci.u"
  }
  else
  {
#line 2755 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0007<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x0e),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+4)= ((opcode)>>0);
*(uint8_t*) (T->mask+5)= ((opcode)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
break;
}
#line 240 "/home/dodo/btstack/src/hci.u"
  }
   return 0;
}
#line 263 "/home/dodo/btstack/src/l2cap.u"

int send_l2cap_frame(thread_t *T,uint16_t coha,uint8_t *frame,int len)
{
   uint8_t *acl_buffer;
   int i,R, retval;
   static int last_number= 1;
   int number;
   uint16_t cp;
   struct libusb_transfer *xfr;
   uint8_t *buffer;
   int first;

   retval= 1;
   first= 1;

   resource_get(T, acl_lock);

again:
   resource_get(T, acl_buffers_resource);

   cp=controller.max_acl_packet_len-4;
   if (cp>len) cp= len;

   acl_buffer= malloc(cp + 4);
 
   i= 0;
   acl_buffer[i++]= coha & 0xff;
   acl_buffer[i++]= (coha & 0x0f00) >> 8;
   acl_buffer[i++]= cp & 0xff;
   acl_buffer[i++]= cp >> 8;

   memcpy(acl_buffer+i, frame, cp);

   if (first) acl_buffer[1] |= 0x20; // first packet
   else acl_buffer[1] |= 0x30;      // continuation packet

   first= 0;

   // print_hex("sending acl data", acl_buffer, len+4);

   number= last_number++;

   xfr= libusb_alloc_transfer(0);
   libusb_fill_bulk_transfer(xfr, device_handle, acl_out_ep, 
                             acl_buffer, len+4, bulk_send_cb,
                             &number, 6000);

   R= libusb_submit_transfer(xfr);
   if (R)
   {
     interpret_error_code("submit-send-bulk", R);
     free(acl_buffer);
     libusb_free_transfer(xfr);
     goto done;
   }

#line 2835 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000b<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x06),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x04<<24) | (0x000c<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= ((number)>>0);
*(uint8_t*) (T->mask+6)= ((number)>>8);
*(uint8_t*) (T->mask+7)= ((number)>>16);
*(uint8_t*) (T->mask+8)= ((number)>>24);
} while(0);
switch(wait_for_events_2(T)){
case 1:
     break;
break;
}
#line 328 "/home/dodo/btstack/src/l2cap.u"
   free(acl_buffer);
   libusb_free_transfer(xfr);

   R= *(int*)(T->edata[0]);
   if (R!=LIBUSB_TRANSFER_COMPLETED)
   {
     printf("submit-send-bulk returned %d in callback, "
             "aborting l2cap frame.\n",R);
     goto done;
   }

   frame+= cp;
   len -= cp;

   if (len==0) { retval= 0; goto done; }
   goto again;

done:
   resource_set(acl_lock, 1);
   return retval;
} 


#line 358 "/home/dodo/btstack/src/l2cap.u"

void l2cap_buffer_monitor(thread_t *T)
{
   int i;
   uint8_t N;
   uint8_t *data, *ncp;
   int nb;

   acl_lock= resource_init(1);
   acl_buffers_resource= resource_init(controller.num_acl_packets);

#line 2897 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0007<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x13),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x04<<24) | (0x0009<<8) | (0x01),
(0x02<<24) | (0x01), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
} while(0);
again:
switch(wait_for_events_2(T)){
case 1:
break;
}
#line 376 "/home/dodo/btstack/src/l2cap.u"
   N= T->edata[0][0];
   data= T->edata[1];

   ncp= data + 2*N;

   // we don't care about the connection handles, we are just
   // wondering about whether the controller's buffers are free 
   // or not.

   nb= 0;
   for(i=0;i<N;i++)
   {
     nb+= get_le16(ncp);
     ncp+= 2;
   }
   resource_add(acl_buffers_resource, nb);

   goto again;
}

#line 508 "/home/dodo/btstack/src/l2cap.u"

void l2cap_signal_thread(thread_t *T, connection_t *C)
{
   int n_channels, s_channels;
   channel_t **channels;
   int last_identifier= 1;
   uint8_t identifier;
   uint16_t local_cid, remote_cid ;
   uint16_t psm;
   channel_t *S;
   uint8_t *options, *options_end;
   uint16_t result;
   uint16_t cmd_data_length,status;
   uint16_t len;
   uint16_t info_type;

   int L; 

   int i;                     uint8_t buffer[255];

   pvecini(&channels, &s_channels, &n_channels);

   print_hex("l2cap signal thread started for device", C->addr, 6);

idle:
#line 2962 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000c<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x15),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0019<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x03),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x0016<<8) | ((0)>>0),
(0x01<<24) | (0x0017<<8) | ((0)>>1),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0026<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x03),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x0016<<8) | ((1)>>0),
(0x01<<24) | (0x0017<<8) | ((1)>>1),
(0x02<<24) | (0x03), 
(0x03<<24) | (0x0031<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x03),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x04), 
(0x03<<24) | (0x003d<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x05),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x04<<24) | (0x0018<<8) | (0x00),
(0x02<<24) | (0x05), 
(0x03<<24) | (0x0049<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x04),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x04<<24) | (0x0016<<8) | (0x00),
(0x02<<24) | (0x06), 
(0x03<<24) | (0x0055<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x08),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x04<<24) | (0x000a<<8) | (0x00),
(0x02<<24) | (0x07), 
(0x03<<24) | (0x0060<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x09),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x08), 
(0x03<<24) | (0x006d<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x0a),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x0012<<8) | ((0x0001)>>0),
(0x01<<24) | (0x0013<<8) | ((0x0001)>>1),
(0x02<<24) | (0x09), 
(0x03<<24) | (0x007a<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x0a),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x0012<<8) | ((0x0002)>>0),
(0x01<<24) | (0x0013<<8) | ((0x0002)>>1),
(0x02<<24) | (0x0a), 
(0x03<<24) | (0x0087<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x0a),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x0012<<8) | ((0x0003)>>0),
(0x01<<24) | (0x0013<<8) | ((0x0003)>>1),
(0x02<<24) | (0x0b), 
(0x03<<24) | (0x0092<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x0a),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x0c), 
(0x03<<24) | (0x009d<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x0b),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x0d), 
(0x03<<24) | (0x00a8<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x06),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x0e), 
(0x03<<24) | (0x00b4<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x19),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x02<<24) | (0x0f), 
(0x03<<24) | (0x00bf<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x07),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x10), 
(0x03<<24) | (0x00ca<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x10),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x01),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x02),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x02<<24) | (0x11), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= (C->addr)[0];
*(uint8_t*) (T->mask+6)= (C->addr)[1];
*(uint8_t*) (T->mask+7)= (C->addr)[2];
*(uint8_t*) (T->mask+8)= (C->addr)[3];
*(uint8_t*) (T->mask+9)= (C->addr)[4];
*(uint8_t*) (T->mask+10)= (C->addr)[5];
*(uint8_t*) (T->mask+20)= ((C->id)>>0);
*(uint8_t*) (T->mask+21)= ((C->id)>>8);
*(uint8_t*) (T->mask+33)= ((C->id)>>0);
*(uint8_t*) (T->mask+34)= ((C->id)>>8);
*(uint8_t*) (T->mask+46)= ((C->id)>>0);
*(uint8_t*) (T->mask+47)= ((C->id)>>8);
*(uint8_t*) (T->mask+57)= ((C->id)>>0);
*(uint8_t*) (T->mask+58)= ((C->id)>>8);
*(uint8_t*) (T->mask+69)= ((C->id)>>0);
*(uint8_t*) (T->mask+70)= ((C->id)>>8);
*(uint8_t*) (T->mask+81)= ((C->id)>>0);
*(uint8_t*) (T->mask+82)= ((C->id)>>8);
*(uint8_t*) (T->mask+93)= ((C->id)>>0);
*(uint8_t*) (T->mask+94)= ((C->id)>>8);
*(uint8_t*) (T->mask+104)= ((C->id)>>0);
*(uint8_t*) (T->mask+105)= ((C->id)>>8);
*(uint8_t*) (T->mask+117)= ((C->id)>>0);
*(uint8_t*) (T->mask+118)= ((C->id)>>8);
*(uint8_t*) (T->mask+130)= ((C->id)>>0);
*(uint8_t*) (T->mask+131)= ((C->id)>>8);
*(uint8_t*) (T->mask+143)= ((C->id)>>0);
*(uint8_t*) (T->mask+144)= ((C->id)>>8);
*(uint8_t*) (T->mask+154)= ((C->id)>>0);
*(uint8_t*) (T->mask+155)= ((C->id)>>8);
*(uint8_t*) (T->mask+165)= ((C->id)>>0);
*(uint8_t*) (T->mask+166)= ((C->id)>>8);
*(uint8_t*) (T->mask+173)= (C->addr)[0];
*(uint8_t*) (T->mask+174)= (C->addr)[1];
*(uint8_t*) (T->mask+175)= (C->addr)[2];
*(uint8_t*) (T->mask+176)= (C->addr)[3];
*(uint8_t*) (T->mask+177)= (C->addr)[4];
*(uint8_t*) (T->mask+178)= (C->addr)[5];
*(uint8_t*) (T->mask+188)= ((C->id)>>0);
*(uint8_t*) (T->mask+189)= ((C->id)>>8);
*(uint8_t*) (T->mask+199)= ((C->id)>>0);
*(uint8_t*) (T->mask+200)= ((C->id)>>8);
} while(0);
switch(wait_for_events_2(T)){
case 1:
psm= T->event[14] | (T->event[15]<<8);
#if 0
   //
   // This is disabled because we might want to connect to the same
   // psm multiple times. i.e. for AVDTP, we need to l2cap connections.
   //
   for(i=0;i<n_channels;i++)
     if (channels[i]->psm==psm) // this means that the psm is busy
       goto connect_fail;
#endif

   local_cid= alloc_local_cid();
   identifier= last_identifier++;
   l2cap_frame(buffer, 1, "bbwww", 0x02, identifier, 4, psm, local_cid);
   if (send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4))
       goto connect_fail;

   S= malloc(sizeof(*S));
   pvecapd(channels, S);

   S->state= 'R';
   S->local_cid= local_cid;
   S->psm= psm;
   S->mtu= 48; // unspecified = minimum. maybe I should do default? (672)
   S->expected_identifier= identifier; 
  
   S->config= 0;
   goto idle;
break;
case 2:
remote_cid= T->event[18] | (T->event[19]<<8);
local_cid= T->event[20] | (T->event[21]<<8);
identifier= T->event[15];
      S= find_channel_by_identifier(identifier,channels, n_channels);
      if (!S) goto idle; // not found, ignore message

      if (check_command_identifier("connect", S, local_cid))
        goto connect_fail_remove;

      S->remote_cid= remote_cid;
      S->state= 'C'; // configuring
      S->config= 0;

      // now we send a config request for the channel

      identifier= last_identifier++;
      l2cap_frame(buffer, 1, "bbw"  "ww" "bbw",
                          0x04, identifier, 4 + 4, 
                          remote_cid, 0,        // cid, flags
                          0x01, 0x02, 0xffff ); // option: mtu=0xffff

      S->expected_identifier= identifier;

      if (send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4))
         goto connect_fail_remove;
      goto idle;
break;
case 3:
status= T->event[24] | (T->event[25]<<8);
identifier= T->event[15];
local_cid= T->event[20] | (T->event[21]<<8);
      S= find_channel_by_identifier(identifier,channels, n_channels);
      if (!S) goto idle;                 // doesn't concern us
      if (check_command_identifier("connect", S, local_cid))
         goto connect_fail_remove;
      printf("L2CAP connection request is pending: status= %02x\n", status);
      goto idle;
break;
case 4:
result= T->event[22] | (T->event[23]<<8);
identifier= T->event[15];
local_cid= T->event[20] | (T->event[21]<<8);
      S= find_channel_by_identifier(identifier,channels, n_channels);
      if (!S) goto idle;                 // doesn't concern us
      check_command_identifier("connect", S, local_cid);
      printf("L2CAP connection request failed with code %02x\n", result);
      goto connect_fail_remove;
break;
case 5:
identifier= T->event[15];
local_cid= T->event[18] | (T->event[19]<<8);
result= T->event[22] | (T->event[23]<<8);
      S= find_channel_by_identifier(identifier, channels, n_channels);
      if (!S) goto idle;
      if (check_command_identifier("config", S, local_cid))
         goto connect_fail_remove;
      if (result==0x0004) // pending
        goto idle;
      if (result!=0) 
      {
        printf("configuration for our maximum MTU somehow failed with. "
                "code %02x. I'm going "
               "to go ahead and ignore this.\n", result);
      } else {
        printf("maximum MTU for inbound messages is set as 0xffff\n");
      }
      S->config |= 1;
      if (S->config==3) goto config_done;
      goto idle;
      // FIXME: I didn't look at the options stuff. 
break;
case 6:
local_cid= T->event[18] | (T->event[19]<<8);
identifier= T->event[15];
cmd_data_length= T->event[16] | (T->event[17]<<8);
  S= find_channel_by_local_cid(local_cid, channels, n_channels);
  if (!S) goto idle;
     
  options= T->edata[0];
  options_end= (cmd_data_length - 4) + options;
  while(options<options_end)
    switch(options[0] & 0x7f)
    {
    case 0x01: // MTU, accept this no matter what.
      len= get_le16(options+1);
      if (len<2) S->mtu= options[3];
      else S->mtu= get_le16(options+3);

    case 0x03:  // Quality of Service, ignored
      options+= get_le16(options+1) + 3;
      continue;
    case 0x04:  // Retransmission and Flow Control
      if (options[3]==0) continue; // Basic Mode Specified, OK.
      goto reject_config_retrans_mode;
    case 0x02:  // Flush Timeout, unsupported
    case 0x05:  // Frame Check Sequence, unsupported (basic mode)
    case 0x06:  // Extended Flow Specification, unsupported
    case 0x07:  // Extended Window Size, unsupported
    default:
      if (!(options[0]&0x80)) // Not a hint, mandatory parameter
        goto reject_config;
      options+= get_le16(options+1) + 3;
    }
// Success, sent options were acceptable. We send a positive reply
// with no options in it.

  l2cap_frame(buffer, 1, "bbw" "ww" "w",
                     0x05, identifier, 6,
                     S->remote_cid, 0,
                     0x0000);

  if (send_l2cap_frame(T,C->id, buffer, get_le16(buffer)+4))
     goto connect_fail_remove; 

  S->config |= 2;
  if (S->config==3 && S->config!='K') 
    goto config_done;
  goto idle; 
break;
case 7:
len= T->event[10] | (T->event[11]<<8);
  T->edata[1][0]= 0x09; // echo response with everything else the same
  send_l2cap_frame(T,C->id, T->edata[0], len+4);
  goto idle;
break;
case 8:
break;
case 9:
identifier= T->event[15];
  l2cap_frame(buffer, 1, "bbwww", 0x0b, identifier, 4, 0x0001, 0x0001);
  // connectionless MTU not supported
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 10:
identifier= T->event[15];
  l2cap_frame(buffer,1,"bbwww" "bbbb",
                        0x0b, identifier, 8, 0x0002, 0x0000,
                        0x80, 0x00, 0x00, 0x00);
    // Extended features supported = fixed channels only
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 11:
identifier= T->event[15];
  l2cap_frame(buffer,1,"bbwww" "bbbb" "bbbb",
                        0x0b, identifier, 12, 0x0003, 0x0000,
                        0x01, 0x00, 0x00, 0x00,
                        0x00, 0x00, 0x00, 0x00);

    // Fixed channels  supported = fixed channel 1 only
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 12:
info_type= T->event[18] | (T->event[19]<<8);
identifier= T->event[15];
  l2cap_frame(buffer, 1, "bbwww", 0x0b, identifier, 4, info_type, 0x0001);
  // unknown info type is not supported
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 13:
break;
case 14:
identifier= T->event[15];
local_cid= T->event[18] | (T->event[19]<<8);
remote_cid= T->event[20] | (T->event[21]<<8);
  S= find_channel_by_local_cid(local_cid, channels, n_channels);
  if (!S)
  { 
     // send a command reject with reason=2=invalid cid in request
    l2cap_frame(buffer,1, "bbw" "www",
                          0x01, identifier, 6,
                          0x0002,local_cid,remote_cid);
    send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
    goto idle;
  }
  if (S->remote_cid!=remote_cid)
    goto idle; // spec says silently discard. OK

  // Now we first tell the agent threads about the disconnection,
  // then we tell the remote device that we're done disconnecting.

  system_event(SYSTEM_l2cap_disconnected, "pw", 6, C->addr, local_cid);

  // Now we can send the disconnect response.
  l2cap_frame(buffer, 1, "bbw" "ww",
                         0x07, identifier, 4,
                         local_cid, remote_cid);
  S= remove_channel(channels, n_channels, S);
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 15:
local_cid= T->event[14] | (T->event[15]<<8);
remote_cid= T->event[16] | (T->event[17]<<8);
  system_event(SYSTEM_l2cap_disconnected, "pw", 6, C->addr, local_cid);

  S= find_channel_by_local_cid(local_cid, channels, n_channels);
  if (S) 
    remove_channel(channels, n_channels, S);

  printf("Disconnecting L2CAP channel L: %d remote: %d\n",
               local_cid, remote_cid);

  identifier= last_identifier++;
  l2cap_frame(buffer, 1, "bbw" "ww",
                         0x06, identifier, 4,
                         remote_cid, local_cid);
  send_l2cap_frame(T, C->id, buffer, get_le16(buffer)+4);
  goto idle;
break;
case 16:
break;
case 17:
identifier= T->event[15];
remote_cid= T->event[20] | (T->event[21]<<8);
   L= bpack(buffer, sizeof(buffer), "lww", 1,   // channel = 1
                    "[bb", 0x03, identifier,  
                    "lw[",
                       "ww", 0, remote_cid, 
                       "ww", 4, 0,  //no resources, no further info
                       "]",
                    "]", NULL);
   send_l2cap_frame(T, C->id, buffer, L);
   goto idle;
break;
}
#line 537 "/home/dodo/btstack/src/l2cap.u"
   goto idle;
#line 681 "/home/dodo/btstack/src/l2cap.u"

connect_fail:
   system_event(SYSTEM_connect_l2cap_fail, "pw", 6, C->addr, psm);
   goto idle;

#line 691 "/home/dodo/btstack/src/l2cap.u"

connect_fail_remove:
   for(i=0;i<n_channels;i++)
     if (channels[i]==S)
     {
       pvecdel(channels,i);
       break;
     }
   goto connect_fail;

#line 795 "/home/dodo/btstack/src/l2cap.u"

config_done:
  if (S->state!='K' && S->config==3)
  {                     // Now we can safely start communication.
    S->state= 'K';
    system_event(SYSTEM_connect_l2cap_ok, "pwwww",6, C->addr,
                  C->id,
                  S->psm, S->local_cid, S->remote_cid);
  }
  goto idle;

reject_config_retrans_mode:
// We reject the config request because we only support basic mode
// and the device wants something else.

  // zero out the option value, so that we send a message,
  // saying we only support basic mode
  memset(options+3, get_le16(options+1), 0);

  l2cap_frame(buffer, 1, "bbw"  "ww" "wp",
                          0x05, identifier, get_le16(options+1)+3+6,
                          S->remote_cid, 0, 
                          0x0001, get_le16(options+1)+3, options);
  if (send_l2cap_frame(T,C->id, buffer, get_le16(buffer)+4))
     goto connect_fail_remove; 
  goto idle;

reject_config:
// We reject the config because we "don't know" about the option.

  l2cap_frame(buffer, 1, "bbw" "ww" "wp",
                           0x05, identifier, get_le16(options+1)+3+6,
                           S->remote_cid, 0,
                           0x0003, get_le16(options+1)+3, options);
  if (send_l2cap_frame(T,C->id, buffer, get_le16(buffer)+4))
     goto connect_fail_remove; 
  goto idle;

#line 539 "/home/dodo/btstack/src/l2cap.u"
}

#line 56 "/home/dodo/btstack/src/poll.u"

void poll_all()
{
  struct timeval tv;
  int R,i,timeout;

#if 0
  R= libusb_get_next_timeout(NULL, &tv);

  printf("NTMO returned %d: %d,%d\n", R, (int) tv.tv_sec, (int) tv.tv_usec);

  if (R && tv.tv_sec==0 && tv.tv_usec==0)
  {
    handle_usb_fds();
    return ;
  }

    // either I don't understand this correctly, or there is a bug
    // in libusb. our bulk_read transfer is always out there waiting.
    // it has to time-out at some point. However, libusb doesn't  
    // report this when I call get_next_timeout. It simply asserts 
    // that there are no pending timeouts. However, when I make the
    // timeout like 5 seconds instead of infinite, then libusb
    // correctly calls the transfer end callback, reporting a timeout
    // properly.
  if (!R) timeout= 5*1000;
  else {
     timeout= tv.tv_sec*1000 + tv.tv_usec/1000;
     timeout-= timeout/8;
  }
#else

   // see the above comment. on linux, get_next_timeout seems to always
   // return 0.
  timeout= 5*1000;
#endif

poll_again:
  for(i=0;i<n_poll_fds;i++)
    poll_fds[i].revents= 0;
  R= poll(poll_fds,n_poll_fds,timeout);
  if (R<0) {
    if (errno==EINTR) goto poll_again;
    fprintf(stderr,"poll() failed with a strange reason: %d (%s). quitting.\n",
                    errno, strerror(errno));
    exit(1);
  }

  if (R==0) {
     handle_usb_fds();
     return ;
  }
  for(i=0;i<n_libusb_fds;i++)
    if (poll_fds[i].revents) {
       handle_usb_fds();
       break;
    }

  for(i=n_libusb_fds;i<n_poll_fds;i++)
  {
    int PE,fd;
    int pold;

    PE= poll_fds[i].revents;
    if (!PE) continue;

    fd= poll_fds[i].fd;

    pold= 0;

    if (PE&POLLIN)
    {
      system_event(SYSTEM_socket_readable, "d", fd);
      PE&= ~POLLIN;
      pold |= POLLIN;
    }

    if (PE&POLLOUT)
    {
      system_event(SYSTEM_socket_writable, "d", fd);
      PE&= ~POLLOUT;
      pold |= POLLOUT;
    }

    if (PE)
    {
      if (pold&POLLIN)
        system_event(SYSTEM_socket_read_exception, "d", fd);

      if (pold&POLLOUT)
        system_event(SYSTEM_socket_write_exception, "d", fd);
    }

    poll_fds[i]= poll_fds[n_poll_fds-1];
    n_poll_fds--;
    i--;
  }
}

#line 172 "/home/dodo/btstack/src/poll.u"

void add_poll_fd(int fd, int how)
{
  struct pollfd *F;
  if (n_poll_fds==1024)
    exit(fprintf(stderr,"something is very wrong, we have too many "
                        "file descriptors to be polled.\n"));
  F= poll_fds + n_poll_fds;
  n_poll_fds++;

  F->fd= fd;
  F->revents= 0;
  if (how=='R')
     F->events= POLLIN | POLLPRI | POLLRDHUP ;
  else if (how=='W')
     F->events= POLLOUT ;
  else 
     F->events= POLLIN | POLLPRI | POLLRDHUP | POLLOUT;
}

#line 262 "/home/dodo/btstack/src/poll.u"

void remove_poll_fd(int fd)
{
  int i;
  for(i=n_libusb_fds;i<n_poll_fds;i++)
  {
    if (poll_fds[i].fd!=fd) continue;
    poll_fds[i]= poll_fds[n_poll_fds-1];
    n_poll_fds--;
    i--;
  }
}

#line 16 "/home/dodo/btstack/src/acl_conn.u"

void acl_connection_manager(thread_t *T)
{
   uint8_t buffer[255];
   int i;
   uint16_t coha, PT;
   device_t *D;
   uint8_t *addr;
   thread_t *child_thread;
   connection_t *C;
   int L;
   uint8_t psrm;

   uint8_t bd_addr[6]; uint8_t link_type;

again:

#line 3687 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0007<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x12),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x000c<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x04),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
} while(0);
switch(wait_for_events_2(T)){
case 1:
       addr= T->edata[0];
       break;
break;
case 2:
memcpy(bd_addr, T->event+8, 6);
link_type= T->event[17];
   if (link_type==1)
   {
     int L;
     D= get_device(bd_addr);  
     if (D->H_acl_connection_handle)
     {
       uint8_t reason;
       reason= 0x0b; //acl connection already exists
       L= bpack(buffer, sizeof(buffer), "pb", 6, bd_addr, reason, NULL);
       send_hci_command_expect_complete(T, OCF(0x0a) | OGF(0x01), buffer, L,0);
       goto again;
     }

     L= bpack(buffer, sizeof(buffer), "pb", 6, bd_addr, 1, NULL);
                                       // accept connection
     send_hci_command_expect_status(T, OCF(0x09) | OGF(0x01), buffer, L);
     goto wait_again; // wait for connection complete.
   } else {
       uint8_t reason;
       reason= 0x1f; //unspecified error
       L= bpack(buffer, sizeof(buffer), "pb", 6, bd_addr, reason, NULL);
       send_hci_command_expect_complete(T, OCF(0x0a) | OGF(0x01), buffer, L,0);
       goto again;
   }
break;
}
#line 43 "/home/dodo/btstack/src/acl_conn.u"
connect:
   D= get_device(addr);

   if (D->H_acl_connection_handle)
   {
      coha= D->ACL_connection_handle;
      goto done;
   }

   if (dg_device_psrm(D->addr, &psrm))
      goto fail;

   PT= 0xcc18;  // FIXME: this seems to work for now

   i= 0;
   i+= put_addr(buffer+i, D->addr);
   i+= put_le16(buffer+i,PT); 
   buffer[i++]= psrm;
   buffer[i++]= 0; 

   if (D->is_live)
      i+= put_le16(buffer+i, D->clock_offset | (1<<15));
   else
      i+= put_le16(buffer+i, D->clock_offset & ~(1<<15));

   buffer[i++]= 0; // don't allow role switch for now

   if (send_hci_command_expect_status(T, OCF(0x05) | OGF(0x01), 
                                         buffer, i))
   {
      printf("Couldn't send Create Connection. Aborting.\n");
      goto fail;
   }
wait_again:

#line 3775 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000f<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x03),
(0x01<<24) | (0x0008<<8) | ((0)>>0),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x01<<24) | (0x0010<<8) | (0x00),
(0x04<<24) | (0x0009<<8) | (0x00),
(0x04<<24) | (0x0011<<8) | (0x01),
(0x04<<24) | (0x0012<<8) | (0x02),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x001b<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x03),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x01<<24) | (0x000e<<8) | (0x00),
(0x01<<24) | (0x000f<<8) | (0x00),
(0x01<<24) | (0x0010<<8) | (0x00),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= (D->addr)[0];
*(uint8_t*) (T->mask+6)= (D->addr)[1];
*(uint8_t*) (T->mask+7)= (D->addr)[2];
*(uint8_t*) (T->mask+8)= (D->addr)[3];
*(uint8_t*) (T->mask+9)= (D->addr)[4];
*(uint8_t*) (T->mask+10)= (D->addr)[5];
*(uint8_t*) (T->mask+19)= (D->addr)[0];
*(uint8_t*) (T->mask+20)= (D->addr)[1];
*(uint8_t*) (T->mask+21)= (D->addr)[2];
*(uint8_t*) (T->mask+22)= (D->addr)[3];
*(uint8_t*) (T->mask+23)= (D->addr)[4];
*(uint8_t*) (T->mask+24)= (D->addr)[5];
} while(0);
switch(wait_for_events_2(T)){
case 1:
   printf("Connection Complete. LT= %02x EE= %02x CH= %04x\n",
            T->edata[1][0], T->edata[2][0], *(uint16_t*) T->edata[0]);

   coha= get_le16(T->edata[0]);
   C= create_connection(D->addr,coha);
   D->H_acl_connection_handle= 1;
   D->ACL_connection_handle= coha;
   child_thread= create_thread((void*) l2cap_signal_thread);
   coth_arg(child_thread->self_ctx,2, C);
   goto done;
break;
case 2:
   printf("Connection Complete with status= 0x%02x\n", T->edata[0][0]);
   goto fail;
break;
}
#line 107 "/home/dodo/btstack/src/acl_conn.u"

done:
   system_event(SYSTEM_device_connected, "pw", 6, D->addr, coha);
   goto again;

fail:
   system_event(SYSTEM_device_not_connected, "p", 6, D->addr);
   goto again;
}

#line 123 "/home/dodo/btstack/src/acl_conn.u"

int connect_device(thread_t *T,uint8_t *addr,uint16_t *coha)
{
   int i;
   uint8_t *buffer;

   system_event(SYSTEM_connect_device, "p", 6, addr);

#line 3858 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x000d<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x13),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x04<<24) | (0x000e<<8) | (0x00),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x0019<<8), 
(0x01<<24) | (0x0004<<8) | (0x03),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x14),
(0x01<<24) | (0x0007<<8) | (0x00),
(0x01<<24) | (0x0008<<8) | (0x00),
(0x01<<24) | (0x0009<<8) | (0x00),
(0x01<<24) | (0x000a<<8) | (0x00),
(0x01<<24) | (0x000b<<8) | (0x00),
(0x01<<24) | (0x000c<<8) | (0x00),
(0x01<<24) | (0x000d<<8) | (0x00),
(0x02<<24) | (0x02), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
*(uint8_t*) (T->mask+5)= (addr)[0];
*(uint8_t*) (T->mask+6)= (addr)[1];
*(uint8_t*) (T->mask+7)= (addr)[2];
*(uint8_t*) (T->mask+8)= (addr)[3];
*(uint8_t*) (T->mask+9)= (addr)[4];
*(uint8_t*) (T->mask+10)= (addr)[5];
*(uint8_t*) (T->mask+18)= (addr)[0];
*(uint8_t*) (T->mask+19)= (addr)[1];
*(uint8_t*) (T->mask+20)= (addr)[2];
*(uint8_t*) (T->mask+21)= (addr)[3];
*(uint8_t*) (T->mask+22)= (addr)[4];
*(uint8_t*) (T->mask+23)= (addr)[5];
} while(0);
switch(wait_for_events_2(T)){
case 1:
     *coha= get_le16(T->edata[0]);
     return 0;
break;
case 2:
     break;
break;
}
#line 146 "/home/dodo/btstack/src/acl_conn.u"
   return 1;
}

int put_addr(uint8_t *D, uint8_t *A)
{
   memcpy(D,A,6);
   return 6;
}

#line 24 "/home/dodo/btstack/src/hci-defs.u"

uint8_t* hci_command_complete_event_data(uint8_t *event)
{
   event += EVENT_HEADER_SIZE;
   event += 2;   // Event Code and Parameter Total Length
   event += 1;   // Num_HCI_Command_Packets 
   event += 2;   // Command_Opcode
   return event;
}

#line 10 "/home/dodo/btstack/src/pairing.u"

void enable_simple_pairing(thread_t *T)
{
  uint8_t buffer[255];
  int i;
  return ;
  printf("enabling simple pairing.\n");
  i= 0;
  buffer[i++]= 1;
  if (send_hci_command_expect_complete(T, OCF(0x56) | OGF(0x03), buffer,i,1))
    printf("Simple Pairing could not be enabled\n");
  else
    printf("Simple Pairing is enabled\n");
 // well, nothing to do, really
}

#line 32 "/home/dodo/btstack/src/pairing.u"

void print_supported_commands(thread_t *T)
{
  uint8_t *B;
  int i,j;
  if (send_hci_command_expect_complete(T, OCF(0x02) | OGF(0x04), NULL,0,1))
    printf("could not read supported commands\n");

  printf("supported commands:\n");

  printf("  "); for(i=0;i<64;i++) if (i%10) printf(" "); else
                                           printf("%d", i/10); printf("\n");
  printf("  "); for(i=0;i<64;i++) printf("%d", i%10); printf("\n");
  
  B= T->edata[0]+1;
  for(j=0;j<8;j++)
  {
  printf("%d ",j);

  for(i=0;i<64;i++)
    {
      if (B[i] & (1<<j))
         printf("X");
      else 
         printf(".");
    }
  printf("\n");
  }
}
#line 40 "/home/dodo/btstack/src/device.u"

device_t *get_device(uint8_t *bd_addr)
{
   device_t *D;

   for(D=devices.next;D!=&devices;D=D->next)
     if (!memcmp(D->addr, bd_addr,6)) return D;

   D= calloc(1,sizeof(*D));

   memcpy(D->addr, bd_addr, 6);

   D->prev= devices.prev;
   D->next= &devices;

   devices.prev->next= D;
   devices.prev= D;

   return D;
}

#line 15 "/home/dodo/btstack/src/pincode.u"

void pincode_thread(thread_t *T)
{
  uint8_t addr[6], pin_sto[17];
  int L;
  uint8_t buffer[256];
again:
#line 4008 "usb-test.c"
do {
static const uint32_t _TPL[]= {
(0x03<<24) | (0x0005<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x16),
(0x02<<24) | (0x01), 
(0x03<<24) | (0x000a<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x17),
(0x02<<24) | (0x02), 
(0x03<<24) | (0x0011<<8), 
(0x01<<24) | (0x0004<<8) | (0x02),
(0x01<<24) | (0x0005<<8) | (0x00),
(0x01<<24) | (0x0006<<8) | (0x18),
(0x04<<24) | (0x0008<<8) | (0x00),
(0x04<<24) | (0x000e<<8) | (0x01),
(0x02<<24) | (0x03), 
(0x02<<24)  | (0),
};
memcpy(T->mask, _TPL, sizeof(_TPL));
} while(0);
switch(wait_for_events_2(T)){
case 1:
memcpy(addr, T->event+8, 6);
    if (dg_device_pin_code(addr, pin_sto))
    {
      char *pin_code;
                // FIXME: get this from the user
      pin_code= get_default_pin_code();
      pin_sto[0]= strlen(pin_code);
      if (pin_sto[0]>16) pin_sto[0]=16;
      memcpy(pin_sto+1, pin_code, pin_sto[0]);
    }
    if (pin_sto[0]>16) pin_sto[0]= 16;

    L= bpack(buffer, sizeof(buffer),
                          "p", 6, addr, 
                          "b", pin_sto[0],
                          "p", 16, pin_sto+1, NULL);
    if (send_hci_command_expect_complete(T, OGF(0x01)|OCF(0x0D),buffer, L,1))
    {
      printf("could not send the pin code reply command\n");
      // nothing to do, connection will fail eventually
    } 
    goto again;
break;
case 2:
memcpy(addr, T->event+8, 6);
   send_link_key(T,addr);
   goto again;
break;
case 3:
   printf("Link Key Notification!\n");
   dp_device_link_key(T->edata[0], T->edata[1]);
   goto again;
break;
}
#line 66 "/home/dodo/btstack/src/pincode.u"

  goto again;

}
#line 17 "/home/dodo/btstack/src/usb-test.u"

int main()
{
  init_env();
  if (db_init())
   printf("Could not open configuration database\n");
#line 255 "/home/dodo/btstack/src/usb-test.u"
 signal(SIGINT, sigint);

#line 269 "/home/dodo/btstack/src/hci.u"

  hci_available_resource= resource_init(1);

#line 131 "/home/dodo/btstack/src/inquiry.u"

  inquiry_lock= resource_init(1);

#line 44 "/home/dodo/btstack/src/l2cap.u"

  pvecini(&connections, &s_connections, &n_connections);

#line 24 "/home/dodo/btstack/src/usb-test.u"
  local_cids_init();
  init_threads();
  if (usb_init()) exit(1);

#line 251 "/home/dodo/btstack/src/poll.u"

  poll_init();
 
#line 29 "/home/dodo/btstack/src/usb-test.u"

  printf("libusb_pollfds_handle_timeouts returns %d\n",
     libusb_pollfds_handle_timeouts(NULL)); 

  create_thread(controller_init); event_loop();

  printf("init OK\n");

  create_thread(pincode_thread);
  create_thread(l2cap_buffer_monitor);
  create_thread(acl_connection_manager);
  create_thread(test_thread);
  event_loop();


  printf("all done, waiting for some events or something\n");

  return 0;
}


