#line 43 "/home/dodo/btstack/src/util.u"

#include <stdint.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "util.h"

#line 79 "/home/dodo/btstack/src/pvector.u"

static void **grow_pvec(void **V)
{
  void **N;
  int *L, *S;
  int size;
  void ***T;

  S= V[-2];

  size= *S;
  size+= size/2;
  
  N= malloc((size+3)*sizeof(void*));
  N+= 3;
  N[-1]= V[-1];
  N[-2]= V[-2];
  N[-3]= V[-3];

  *S= size;

  memcpy(N, V, size*sizeof(void*));

  T= N[-1];
  *T= N;
  free(V-3);
  return N;
}

#line 51 "/home/dodo/btstack/src/util.u"

#line 8 "/home/dodo/btstack/src/util.u"

int bscan(uint8_t *B, const char* fmt, ...)
{
  uint8_t *oB;
  va_list ap;
  oB= B;
  va_start(ap,fmt);
  while(*fmt)
   switch(*(fmt++))
   {
     case 'b': *(va_arg(ap, uint8_t*))= (B[0] << 0);  B+=1; break;
     case 'W': *(va_arg(ap, uint16_t*))= (B[0] << 8) | (B[1]<<0); B+=2; break;
     case 'w': *(va_arg(ap, uint16_t*))= (B[0] << 0) | (B[1]<<8); B+=2; break;
     case 'd': *(va_arg(ap, uint32_t*))= (B[0] << 0) | (B[1]<<8)
                                        |(B[2] << 16)| (B[3]<<24); B+=4; break;
     case 'D': *(va_arg(ap, uint32_t*))= (B[0] << 24)| (B[1]<<16)
                                        |(B[2] << 8) | (B[3]<<0); B+=4; break;
   }
  va_end(ap);
  return B- oB;
}

#line 46 "/home/dodo/btstack/src/pvector.u"

void _pvecini(void ***T, int *size, int *length)
{
  void **V;

  V= malloc(sizeof(void*)*(3+20));
  V+= 3;
  V[-1]= (void*) T;
  V[-2]= size;
  V[-3]= length;
  *size= 20;
  *length= 0;
  *T= V;
}

#line 65 "/home/dodo/btstack/src/pvector.u"

void _pvecapd(void **V, void *D)
{
   int *L, *S;
   L= V[-3];
   S= V[-2];

   if (*L==*S) V= grow_pvec(V);

   V[*L]= D;
   (*L)++;
}

#line 114 "/home/dodo/btstack/src/pvector.u"

void _pvecdel(void **V, int index)
{
  int *L;
  int len;

  L= V[-3];
  len= *L;

  if (len==0) return ;
  
  len--;
  if (index<len)
     V[index]= V[len];
  *L= len;
}

#line 136 "/home/dodo/btstack/src/pvector.u"

void _pvecfre(void **X)
{
   void ***T;
   int *S, *L;
   T= X[-1];
   S= X[-2];
   L= X[-3];

   *T= 0;
   *S= 0;
   *L= 0;
   free(X-3);
}

#line 53 "/home/dodo/btstack/src/util.u"



