#ifndef MBOX_H_INCLUDED
#define MBOX_H_INCLUDED

typedef struct mbox mbox_t;

#ifdef __cplusplus
extern "C" {
#endif

mbox_t *mbox_new();
int mbox_fd(mbox_t *m);
void mbox_put(mbox_t *m, void *data);
void* mbox_get(mbox_t *m);

// This one clears all the messages in the mbox, it should be used by the
// sender to cancel messages already put in the pipeline.
void mbox_clear(mbox_t *m);

// If there is a message tagged with 'tag', this function clears all
// messages preceding it, along with the tagged message. It doesn't
// block. It returns 1 if such a message was found and 0 otherwise.
// This should be used by the receiver to check for a stop signal.
int mbox_clear_to_nb(mbox_t *m,int tag);


#ifdef __cplusplus
}
#endif

#endif
