#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mpg123.h>

int main(int argc,char **argv)
{
  unsigned char *B;
  off_t O;
  size_t L;
  int R;
  mpg123_handle *mp3h;

  R= mpg123_init();
  if (R!=MPG123_OK)
    exit(fprintf(stderr,"mpg123_init(): %s\n", mpg123_plain_strerror(R)));

  mp3h= mpg123_new(NULL, &R);
  if (!mp3h)
   exit(fprintf(stderr,"mpg123_new(): %s\n", mpg123_plain_strerror(R)));

  mpg123_format_none(mp3h);
  mpg123_format(mp3h, 44100, MPG123_STEREO, MPG123_ENC_SIGNED_16);

  R= mpg123_open(mp3h, argv[1]);
  if (R!=MPG123_OK)
   exit(fprintf(stderr,"mpg123_open(): %s\n", mpg123_strerror(mp3h)));
  
  while(1)
  {
    R= mpg123_decode_frame(mp3h, &O, &B, &L);
    if (R==MPG123_NEW_FORMAT)
    {
      long rate; int chans; int enco;
      mpg123_getformat(mp3h, &rate, &chans, &enco);
      fprintf(stderr,"new format: rate= %ld channels=%d encoding= %d\n",
                   rate, chans,enco);
      continue;
    }
    if (R!=MPG123_OK) break;
    write(1, B, L);
  }
  if (R!=MPG123_DONE)
    exit(fprintf(stderr,"decoding ended prematurely: %s\n",
              mpg123_strerror(mp3h)));
  mpg123_close(mp3h);
  mpg123_delete(mp3h);
  mpg123_exit();
  fprintf(stderr,"all done.\n");
  return 0;
}
